{g-vars.i &vsh = "shared"}
{show-header-frame-def.i}

screen-title = "Check Out".

def var sprog as char init ?.
def var selection as char init ?.

def buffer b-checkout for checkout.
def buffer b-out-room for checkout-rooms.
def buffer b-room for room.
def buffer b-guest for guest.
def buffer b-res for reservation.

def var r-id like reservation.reservation-id.
def var r-discount like reservation.discount.
def var r-checkin like reservation.checkin.
def var r-checkout like reservation.checkout.
def var r-days as char format "x(7)".
def var r-tguests as char format "x(10)".
def var c-charges like checkout.room-charges.
def var c-salestax like checkout.sales-tax.
def var c-total like checkout.total.
def var cr-guest-ids like checkout-room.guest-ids.
def var cr-guest-names as char extent 4 format "x(20)".
def var cr-minibar like checkout-room.minibar-charges.
def var cr-laundry like checkout-room.laundry-charges.
def var cr-charges like checkout-room.room-charges.
def var cr-total like  checkout-room.room-charges label "Total".

form r-id space(3) r-checkin r-checkout skip
     space(60) r-days no-label r-tguests no-label
     with frame f-checkout title "Checkout" size 80 by 20 side-labels at row 2 col 1.
     
form c-charges at row 1 col 15 colon-aligned 
     r-discount at row 2 col 15 colon-aligned
     c-salestax at row 3 col 15 colon-aligned
     c-total at row 4 col 15 colon-aligned 
     with frame f-charges title "Total" side-labels.
     
frame f-charges:frame = frame f-checkout:handle.
frame f-charges:row = 4.
frame f-charges:col = 1.

form cr-minibar at row 1 col 16 colon-aligned skip
     cr-laundry at row 2 col 16 colon-aligned  skip
     cr-charges at row 3 col 16 colon-aligned  skip
     cr-total at row 4 col 16 colon-aligned  skip(2)
     "-------------Guests-----------" at row 5 col 1 view-as text skip
     cr-guest-ids[1] no-label space(1) cr-guest-names[1] no-label skip
     cr-guest-ids[2] no-label space(1) cr-guest-names[2] no-label skip
     cr-guest-ids[3] no-label space(1) cr-guest-names[3] no-label skip
     cr-guest-ids[4] no-label space(1) cr-guest-names[4] no-label
     with frame f-room title "Room" side-labels.
     
frame f-room:frame = frame f-checkout:handle.
frame f-room:row = 4.
frame f-room:col = frame f-checkout:width-chars - frame f-room:width-chars - 2.

def query q-checkout for checkout, reservation scrolling.
open query q-checkout
   for each checkout no-lock,
       each reservation
         where reservation.reservation-id = checkout.reservation-id and
               /* reservation.checkout >= today and reservation.checkin <= today and */
                (checkout.state = 'I' or checkout.state = "O") no-lock use-index idx-r-id.
def query q-room for checkout-room scrolling. 


procedure open-q-room.
   open query q-room 
      for each checkout-room
         where checkout-room.reservation-id = checkout.reservation-id no-lock use-index idx-rc-room.
   get first q-room.
end.

procedure refresh.
   if not avail checkout-room then do:
      clear frame f-checkout all.
      clear frame f-charges all.
      clear frame f-room all.
      
      return.
   end.
   
   r-id = reservation.reservation-id.
   r-discount = reservation.discount.
   r-checkin = reservation.checkin.
   r-checkout = reservation.checkout.
   r-days = string(reservation.checkout - reservation.checkin) + " Days".
   
   def var t-guests as int.
   t-guests = 0.
   
   for each b-out-room where b-out-room.reservation-id = reservation.reservation-id:
      def var tid as int.
      do tid = 1 to extent(b-out-room.guest-ids):
         if b-out-room.guest-ids[tid] <> ? and b-out-room.guest-ids[tid] <> 0
            then t-guests = t-guests + 1.
      end.
   end.
   
   r-tguests = string(t-guests) + " Guests".

   c-charges = checkout.room-charges.
   c-salestax = checkout.sales-tax.
   c-total = checkout.total.
   
   cr-minibar = 0.
   cr-laundry = 0.
   cr-charges = 0.
   cr-guest-ids = ?.
   cr-guest-names = "".
   
   if avail checkout-room then do:
      find room where room.room-number = checkout-room.room-number.
      
      frame f-room:title = "[" + room-types[room.type-of-room] + "] - " + string(room.room-number).
      
      cr-minibar = checkout-room.minibar-charges.
      cr-laundry = checkout-room.laundry-charges.
      cr-charges = checkout-room.room-charges.
      cr-guest-ids = checkout-room.guest-ids.
      
      def var gid as int.
      do gid = 1 to extent(cr-guest-ids):
         find first guest where guest.guest-id = cr-guest-ids[gid] no-lock no-error.
         if avail guest then do:
            cr-guest-names[gid] = guest.last-name + ", " + guest.first-name.
         end.
      end.
   end.
   
   cr-total = cr-minibar + cr-laundry + cr-charges.
   
   display r-id r-checkin r-checkout r-days r-tguests with frame f-checkout.
   display c-charges r-discount c-salestax c-total with frame f-charges.
   display cr-minibar
           cr-laundry
           cr-charges
           cr-total
           cr-guest-ids[1] when can-find(guest where guest.guest-id = cr-guest-ids[1])
           cr-guest-names[1] when can-find(guest where guest.guest-id = cr-guest-ids[1])
           cr-guest-ids[2] when can-find(guest where guest.guest-id = cr-guest-ids[2]) 
           cr-guest-names[2] when can-find(guest where guest.guest-id = cr-guest-ids[2])
           cr-guest-ids[3] when can-find(guest where guest.guest-id = cr-guest-ids[3])
           cr-guest-names[3] when can-find(guest where guest.guest-id = cr-guest-ids[3])
           cr-guest-ids[4] when can-find(guest where guest.guest-id = cr-guest-ids[4]) 
           cr-guest-names[4] when can-find(guest where guest.guest-id = cr-guest-ids[4])
        with frame f-room.
end.

get first q-checkout.
run open-q-room.
run refresh.

PROC:
repeat:
   {show-header.i}
   
   sprog = ?.
   case selection:
      when "P" then do:
         get prev q-checkout.
         if not avail checkout then do:
            get first q-checkout.
         end.

         run open-q-room.
         run refresh.
      end.
      when "N" then do:
         get next q-checkout.
         if not avail checkout then do:
            get last q-checkout.
         end.

         run open-q-room.
         run refresh.
      end.
      when "F" then do:
         get first q-checkout.
         run open-q-room.
         run refresh.
      end.
      when "L" then do:
         get last q-checkout.
         run open-q-room.
         run refresh.
      end.
      when "I" then do:
         r-id = ?.
         def var f-room-id like room.room-number.
         f-room-id = ?.
      
         /* find by name, date of birth */
         def button btn-ok label "Find".
         def button btn-cancel label "Cancel".
         
         def var g-room like room.room-number.
         def var g-f-n like guest.first-name.
         def var g-l-n like guest.last-name.
         
         form g-room skip
              g-f-n skip
              g-l-n skip
              btn-ok
              btn-cancel
              with frame f-checkout-search side-labels overlay at row 2 col 1 title "Find Reservation"
                   cancel-button btn-cancel default-button btn-ok.

         on "choose" of btn-cancel in frame f-checkout-search do:
            apply "f4" to frame f-checkout-search.
         end.
         on "choose" of btn-ok in frame f-checkout-search do:
            apply "go" to frame f-checkout-search.
         end.

         /* FIND: by room number, guest first/last name*/
         G-SEARCH:
         repeat on endkey undo, leave:
            
            g-room = 0.
            g-f-n = "".
            g-l-n = "".
            update g-room g-f-n g-l-n btn-ok btn-cancel with frame f-checkout-search.
            
            if g-f-n = "" and g-l-n = "" and (g-room = 0 or g-room = ?)
            then do:
               message "Enter at least one search criteria!".
               next g-search.
            end.
            
            if g-room > 0 then do:
               find first b-out-room where b-out-room.room-number = g-room no-lock no-error.
               if not avail b-out-room then do:
                  message "No guests are in room " + string(g-room) + "!" view-as alert-box.
                  next G-SEARCH.
               end.
               
               f-room-id = g-room.
               r-id = b-out-room.reservation-id.
               leave G-SEARCH.
            end.
      
            for each b-guest 
               where (if g-f-n = ? or g-f-n = "" then true else b-guest.first-name matches g-f-n + "*") and 
                     (if g-l-n = ? or g-l-n = "" then true else b-guest.last-name matches g-l-n + "*") no-lock,
                each b-res where b-res.checkout >= today use-index idx-r-checkin no-lock,
                each b-out-room where b-out-room.reservation-id = b-res.reservation-id and
                     (b-out-room.guest-ids[1] = b-guest.guest-id or
                      b-out-room.guest-ids[2] = b-guest.guest-id or
                      b-out-room.guest-ids[3] = b-guest.guest-id or
                      b-out-room.guest-ids[4] = b-guest.guest-id) no-lock:
                
                f-room-id = b-out-room.room-number.
                r-id = b-res.reservation-id.
                leave G-SEARCH.
            end.
            
            message "No guests found with this criteria!" view-as alert-box.
         end.
         hide frame f-checkout-search no-pause.
         
         if r-id <> ? then do:
            find checkout where checkout.reservation-id = r-id no-lock.
            find reservation where reservation.reservation-id = r-id no-lock.
            reposition q-checkout to rowid rowid(checkout), rowid(reservation).
            get next q-checkout.

            run open-q-room.
            find checkout-room where checkout-room.reservation-id = r-id and checkout-room.room-number = f-room-id no-lock.
            reposition q-room to rowid rowid(checkout-room).
            get next q-room.
            run refresh.
         end.
      end.
      when "K" then do:
         if not avail reservation then leave.
         
         do transaction on endkey undo, leave:
            for each b-out-room where b-out-room.reservation-id = reservation.reservation-id:
               
               find b-room where b-room.room-number = b-out-room.room-number.
               
               frame f-room:title = "[" + room-types[b-room.type-of-room] + "] - " + string(b-room.room-number).
               
               update cr-minibar cr-laundry with frame f-room.
               
               b-out-room.minibar-charges = cr-minibar.
               b-out-room.laundry-charges = cr-laundry.
            end.

            find b-checkout where recid(b-checkout) = recid(checkout) exclusive-lock.
            b-checkout.room-charges = 0.
            for each b-out-room where b-out-room.reservation-id = reservation.reservation-id:
               b-checkout.room-charges = b-checkout.room-charges + b-out-room.minibar-charges + b-out-room.laundry-charges + b-out-room.room-charges. 
            end.

            b-checkout.sales-tax = b-checkout.room-charges * 0.19.
            b-checkout.total = b-checkout.room-charges * ((100.0 - reservation.discount) / 100.0) + b-checkout.sales-tax.
         end.
         
         find current checkout.
         find current room.
         
         run refresh.
      end.
      when "1" then do:
         get prev q-room. 
         if not avail checkout-room then do:
            get first q-room.
         end.
         
         run refresh.
      end.
      when "2" then do:
         get next q-room. 
         if not avail checkout-room then do:
            get last q-room.
         end.
         
         run refresh.
      end.
      
      when "R" then do:
         publish "pop-program".
         leave PROC.
      end.
      otherwise do:
         if selection <> ? then do:
            message "Invalid selection - try again".
            selection = ?.
            pause.
            next. 
         end.
      end.
   end.

   if sprog <> ? then leave PROC.

   {wait-selection.i
      &sele1="(P)rev   (N)ext   (F)irst   (L)ast"
      &sele2="F(i)nd   Chec(k) out   (1) Next Room   (2) Prev Room   "
      }
end.

if sprog <> ? then do:
   publish "push-program" (sprog).
end.
