{g-vars.i &vsh = "new shared"}

room-types[1] = "1 bed king".
room-types[2] = "1 bed queen".
room-types[3] = "2 beds".
room-types[4] = "1 room apt".
room-types[5] = "2 room apt".

res-state[1] = "Placed".
res-state[2] = "Canceled".
res-state[3] = "Checked in".
res-state[4] = "Checked out".

res-state-ch[1] = "P".
res-state-ch[2] = "C".
res-state-ch[3] = "I".
res-state-ch[4] = "O".

def var cur-prog as char no-undo extent 10.
def var cur-prog-idx as int no-undo.
def var start-prog as char init "menu.p" no-undo.

/*
TODO: determine start-prog based on rights/entry-point/authenticated user
TODO: help
*/

procedure push-program.
   def input param prog as char.
   cur-prog-idx = cur-prog-idx + 1.
   cur-prog[cur-prog-idx] = prog.
end.

procedure pop-program.
   cur-prog[cur-prog-idx] = ?.
   cur-prog-idx = cur-prog-idx - 1.
end.

function peek-program returns char.
   return cur-prog[cur-prog-idx].
end.

procedure set-room-types-combo.
   def input param h as handle.
   def var ch as char.
   def var i as int.
   do i = 1 to extent(room-types):
      ch = ch + (if i = 1 then "" else ",") + room-types[i] + "," + string(i).
   end.
   
   h:list-item-pairs = ch.
end.

session:add-super-procedure(this-procedure).

subscribe procedure this-procedure to "push-program" anywhere.
subscribe procedure this-procedure to "pop-program" anywhere.

publish "push-program" (start-prog).

repeat on endkey undo, retry
       on stop undo, retry
       on error undo, retry
       on quit undo, leave:

   hide all no-pause.
   hide message no-pause.

   def var v-stop as log.
   
   v-stop = true.
   
   prog-started = false.
   
   do on stop undo, leave:

      do on error undo, leave
         on endkey undo, leave:
         /* ignore error/endkey, as the program was able to be run */
         run value(peek-program()).
      end.

      v-stop = false.
   end.
   
   if v-stop then do:

      if prog-started then do:
         /* re-init the program */
         
         cur-prog = ?.
         cur-prog-idx = 0.
         publish "push-program" (start-prog).
         
      end.
      else do:
         message "Program" peek-program() "could not be executed." view-as alert-box.
   
         hide message no-pause.
         hide all no-pause.
         status default.
         put screen color normal row screen-lines + 1 fill(" ", 78).
         put screen color normal row screen-lines + 2 fill(" ", 78).
   
         next.
      end.
   end.
end.

quit.