package com.goldencode.hotel;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.hotel.dmo.hotel.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.p2j.persist.lock.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in empty-db.p).
 */
public class EmptyDb
{
   Checkout.Buf checkout = RecordBuffer.define(Checkout.Buf.class, "hotel", "checkout", "checkout");

   CheckoutRooms.Buf checkoutRooms = RecordBuffer.define(CheckoutRooms.Buf.class, "hotel", "checkoutRooms", "checkout-rooms");

   Guest.Buf guest = RecordBuffer.define(Guest.Buf.class, "hotel", "guest", "guest");

   Rate.Buf rate = RecordBuffer.define(Rate.Buf.class, "hotel", "rate", "rate");

   Reservation.Buf reservation = RecordBuffer.define(Reservation.Buf.class, "hotel", "reservation", "reservation");

   ReservationRooms.Buf reservationRooms = RecordBuffer.define(ReservationRooms.Buf.class, "hotel", "reservationRooms", "reservation-rooms");

   Room.Buf room = RecordBuffer.define(Room.Buf.class, "hotel", "room", "room");

   RoomState.Buf roomState = RecordBuffer.define(RoomState.Buf.class, "hotel", "roomState", "room-state");

   /**
    * External procedure (converted to Java from the 4GL source code
    * in empty-db.p).
    */
   public void execute()
   {
      externalProcedure(EmptyDb.this, new Block((Body) () -> 
      {
         PreselectQuery query0 = new PreselectQuery();
         
         forEach(TransactionType.FULL, "loopLabel0", new Block((Init) () -> 
         {
            RecordBuffer.openScope(checkout);
            query0.initialize(checkout, ((String) null), null, "checkout.reservationId asc");
         }, 
         (Body) () -> 
         {
            query0.next();
            checkout.deleteRecord();
         }));
         
         PreselectQuery query1 = new PreselectQuery();
         
         forEach(TransactionType.FULL, "loopLabel1", new Block((Init) () -> 
         {
            RecordBuffer.openScope(checkoutRooms);
            query1.initialize(checkoutRooms, ((String) null), null, "checkoutRooms.roomNumber asc");
         }, 
         (Body) () -> 
         {
            query1.next();
            checkoutRooms.deleteRecord();
         }));
         
         PreselectQuery query2 = new PreselectQuery();
         
         forEach(TransactionType.FULL, "loopLabel2", new Block((Init) () -> 
         {
            RecordBuffer.openScope(guest);
            query2.initialize(guest, ((String) null), null, "guest.guestId asc");
         }, 
         (Body) () -> 
         {
            query2.next();
            guest.deleteRecord();
         }));
         
         PreselectQuery query3 = new PreselectQuery();
         
         forEach(TransactionType.FULL, "loopLabel3", new Block((Init) () -> 
         {
            RecordBuffer.openScope(rate);
            query3.initialize(rate, ((String) null), null, "rate.startDate asc");
         }, 
         (Body) () -> 
         {
            query3.next();
            rate.deleteRecord();
         }));
         
         PreselectQuery query4 = new PreselectQuery();
         
         forEach(TransactionType.FULL, "loopLabel4", new Block((Init) () -> 
         {
            RecordBuffer.openScope(reservation);
            query4.initialize(reservation, ((String) null), null, "reservation.reservationId asc");
         }, 
         (Body) () -> 
         {
            query4.next();
            reservation.deleteRecord();
         }));
         
         PreselectQuery query5 = new PreselectQuery();
         
         forEach(TransactionType.FULL, "loopLabel5", new Block((Init) () -> 
         {
            RecordBuffer.openScope(reservationRooms);
            query5.initialize(reservationRooms, ((String) null), null, "reservationRooms.id asc");
         }, 
         (Body) () -> 
         {
            query5.next();
            reservationRooms.deleteRecord();
         }));
         
         PreselectQuery query6 = new PreselectQuery();
         
         forEach(TransactionType.FULL, "loopLabel6", new Block((Init) () -> 
         {
            RecordBuffer.openScope(room);
            query6.initialize(room, ((String) null), null, "room.roomNumber asc");
         }, 
         (Body) () -> 
         {
            query6.next();
            room.deleteRecord();
         }));
         
         PreselectQuery query7 = new PreselectQuery();
         
         forEach(TransactionType.FULL, "loopLabel7", new Block((Init) () -> 
         {
            RecordBuffer.openScope(roomState);
            query7.initialize(roomState, ((String) null), null, "roomState.id asc");
         }, 
         (Body) () -> 
         {
            query7.next();
            roomState.deleteRecord();
         }));
         
         message("done");
      }));
   }
}
