package com.goldencode.hotel;

import com.goldencode.p2j.util.*;
import com.goldencode.hotel.ui.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.hotel.dmo.hotel.*;
import com.goldencode.util.*;
import com.goldencode.p2j.persist.lock.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.SQLHelper.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in guests.p).
 */
public class Guests
{
   public static final String FMT_STR_1 = ">,>>>,>>9";

   public static final String FMT_STR_2 = "x(25)";

   public static final String FMT_STR_3 = "99/99/99";

   public static final String FMT_STR_4 = "9";

   public static final String FMT_STR_5 = "x(20)";

   public static final String FMT_STR_6 = "(999)999-9999";

   public static final String FMT_STR_7 = "x(10)";

   Guest.Buf bGuest = RecordBuffer.define(Guest.Buf.class, "hotel", "bGuest", "b-guest");

   Guest.Buf guest = RecordBuffer.define(Guest.Buf.class, "hotel", "guest", "guest");

   GuestsFGuestSearch fGuestSearchFrame = GenericFrame.createFrame(GuestsFGuestSearch.class, "f-guest-search");

   GuestsFMainHeader fMainHeaderFrame = GenericFrame.createFrame(GuestsFMainHeader.class, "f-main-header");

   GuestsFGuest fGuestFrame = GenericFrame.createFrame(GuestsFGuest.class, "f-guest");

   logical progStarted = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "prog-started", new logical(false));

   character uName = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "u-name", new character(""));

   character screenTitle = SharedVariableManager.lookupVariable("screen-title", character.class);

   integer gId = UndoableFactory.integer((long) 0);

   character gFN = UndoableFactory.character("");

   character gLN = UndoableFactory.character("");

   date gDob = UndoableFactory.date();

   integer gIdType = TypeFactory.integer((long) 0);

   character gIdNumber = TypeFactory.character("");

   character gPhoneNumber = UndoableFactory.character("");

   character gStreet1 = UndoableFactory.character("");

   character gStreet2 = UndoableFactory.character("");

   character gCity = UndoableFactory.character("");

   character gState = UndoableFactory.character("");

   character gZip = UndoableFactory.character("");

   character gCountry = UndoableFactory.character("");

   final QueryWrapper query0 = new QueryWrapper("q-guest", true);

   /**
    * External procedure (converted to Java from the 4GL source code
    * in guests.p).
    */
   public void execute()
   {
      character hTime = UndoableFactory.character();
      character selection = UndoableFactory.character(null);
      
      externalProcedure(Guests.this, new Block((Body) () -> 
      {
         query0.addBuffer(guest, true);
         fMainHeaderFrame.openScope();
         fGuestFrame.openScope();
         RecordBuffer.openScope(guest);
         progStarted.assign(true);
         screenTitle.assign("Guest Info Management");
         
         fGuestFrame.view();
         query0.assign(new AdaptiveQuery().initialize(guest, ((String) null), null, "guest.guestId asc"));
         query0.open();
         query0.first();
         ControlFlowOps.invoke("refresh");
         
         repeat("proc", new Block((Init) () -> 
         {
            fGuestSearchFrame.openScope();
            RecordBuffer.openScope(bGuest);
         }, 
         (Body) () -> 
         {
            if (_or(isUnknown(uName), () -> isEqual(uName, "")))
            {
               messageBox("You are not logged in - access denied", ALERT_MESSAGE, BTN_OK, (String) null);
               quit();
            }
            
            hTime.assign(valueOf(datetimetz.now(), "99/99/99 HH:MM:SS"));
            hTime.assign(substring(hTime, 10));
            
            doBlock("blockLabel0", new Block((Body) () -> 
            {
               fMainHeaderFrame.widgetUName().setColumn(new decimal(new integer(1)));
               fMainHeaderFrame.widgetScreenTitle().setColumn(plus(plus(fMainHeaderFrame.widgetUName().getColumn(), length(uName)), divide(minus(minus(minus(fMainHeaderFrame.getWidthChars(), length(uName)), length(screenTitle)), length(hTime)), 2)));
               fMainHeaderFrame.widgetHTime().setColumn(minus(fMainHeaderFrame.getWidthChars(), length(hTime)));
               fMainHeaderFrame.widgetScreenTitle().setFormat(concat("x(", valueOf(length(screenTitle)), ")"));
            }));
            
            FrameElement[] elementList1 = new FrameElement[]
            {
               new Element(uName, fMainHeaderFrame.widgetUName()),
               new Element(screenTitle, fMainHeaderFrame.widgetScreenTitle()),
               new Element(hTime, fMainHeaderFrame.widgetHTime())
            };
            
            fMainHeaderFrame.display(elementList1);
            
            switch (StringHelper.safeTrimTrailing((selection).toStringMessage()).toUpperCase())
            {
               case "P":
                  {
                     query0.previous();
                     
                     if (_not(guest.available()))
                     {
                        query0.first();
                     }
                     
                     ControlFlowOps.invoke("refresh");
                  }
                  break;
               case "N":
                  {
                     query0.next();
                     
                     if (_not(guest.available()))
                     {
                        query0.last();
                     }
                     
                     ControlFlowOps.invoke("refresh");
                  }
                  break;
               case "F":
                  {
                     query0.first();
                     ControlFlowOps.invoke("refresh");
                  }
                  break;
               case "L":
                  {
                     query0.last();
                     ControlFlowOps.invoke("refresh");
                  }
                  break;
               case "I":
                  {
                     registerTrigger(new EventList("choose", fGuestSearchFrame.widgetBtnCancel()), Guests.this, new Trigger((Body) () -> 
                     {
                        fGuestSearchFrame.apply("f4");
                     }));
                     
                     registerTrigger(new EventList("choose", fGuestSearchFrame.widgetBtnOk()), Guests.this, new Trigger((Body) () -> 
                     {
                        fGuestSearchFrame.apply("go");
                     }));
                     
                     OnPhrase[] onPhrase0 = new OnPhrase[]
                     {
                        new OnPhrase(Condition.ENDKEY, Action.LEAVE, "gSearch")
                     };
                     
                     repeat("gSearch", onPhrase0, new Block((Body) () -> 
                     {
                        gFN.assign("");
                        gLN.assign("");
                        gDob.setUnknown();
                        
                        FrameElement[] elementList2 = new FrameElement[]
                        {
                           new Element(gFN, fGuestSearchFrame.widgetGFN()),
                           new Element(gLN, fGuestSearchFrame.widgetGLN()),
                           new Element(gDob, fGuestSearchFrame.widgetGDob()),
                           new WidgetElement(fGuestSearchFrame.widgetBtnOk()),
                           new WidgetElement(fGuestSearchFrame.widgetBtnCancel())
                        };
                        
                        fGuestSearchFrame.update(elementList2);
                        
                        if (_and(and(isEqual(gFN, ""), () -> isEqual(gLN, "")), () -> isUnknown(gDob)))
                        {
                           message("Enter at least one search criteria!");
                           next("gSearch");
                        }
                        
                        ErrorManager.silentErrorEnable();
                        new FindQuery(bGuest, "case when ? then true else upper(bGuest.firstName) like ? end and case when ? then true else upper(bGuest.lastName) like ? end and case when ? then true else bGuest.dateOfBirth = ? end", null, "bGuest.guestId asc", new Object[]
                        {
                           or(isUnknown(gFN), () -> isEqual(gFN, "")),
                           toUpperCase(convertToSQLLike(concat(gFN, "*"), false)),
                           or(isUnknown(gLN), () -> isEqual(gLN, "")),
                           toUpperCase(convertToSQLLike(concat(gLN, "*"), false)),
                           isUnknown(gDob),
                           gDob
                        }, LockType.NONE).first();
                        ErrorManager.silentErrorDisable();
                        
                        if (bGuest._available())
                        {
                           query0.repositionByID(bGuest.rowID());
                           query0.next();
                           ControlFlowOps.invoke("refresh");
                        }
                        else
                        {
                           message("No matching record found.");
                           next("gSearch");
                        }
                        
                        leave("gSearch");
                     }));
                     
                     fGuestSearchFrame.hide(true);
                  }
                  break;
               case "D":
                  {
                     if (guest._available())
                     {
                        doBlock(TransactionType.FULL, "blockLabel1", new Block((Body) () -> 
                        {
                           new FindQuery(bGuest, "bGuest.guestId = ?", null, "bGuest.guestId asc", new Object[]
                           {
                              (P2JQuery.Parameter) () -> guest.getGuestId()
                           }, LockType.EXCLUSIVE).unique();
                           bGuest.deleteRecord();
                           query0.previous();
                        }));
                     }
                     
                     ControlFlowOps.invoke("refresh");
                  }
                  break;
               case "A":
                  {
                     OnPhrase[] onPhrase1 = new OnPhrase[]
                     {
                        new OnPhrase(Condition.ERROR, Action.LEAVE, "addGuest"),
                        new OnPhrase(Condition.ENDKEY, Action.LEAVE, "addGuest")
                     };
                     
                     doBlock(TransactionType.FULL, "addGuest", onPhrase1, new Block((Body) () -> 
                     {
                        repeat("createGuest", new Block((Body) () -> 
                        {
                           OnPhrase[] onPhrase2 = new OnPhrase[]
                           {
                              new OnPhrase(Condition.ERROR, Action.RETRY, "blockLabel2")
                           };
                           
                           doBlock(TransactionType.FULL, "blockLabel2", onPhrase2, new Block((Body) () -> 
                           {
                              ErrorManager.silentErrorEnable();
                              new FindQuery(bGuest, (String) null, null, "bGuest.guestId asc", LockType.NONE).last();
                              ErrorManager.silentErrorDisable();
                              gId.assign((bGuest._available() ? plus(bGuest.getGuestId(), 1) : new int64(1)));
                              bGuest.release();
                              bGuest.create();
                              bGuest.setGuestId(gId);
                              leave("createGuest");
                           }));
                        }));
                        
                        fGuestFrame.clearAll(false);
                        
                        FrameElement[] elementList3 = new FrameElement[]
                        {
                           new Element(gId, fGuestFrame.widgetGId())
                        };
                        
                        fGuestFrame.display(elementList3);
                        
                        gFN.assign("");
                        gLN.assign("");
                        gDob.setUnknown();
                        gIdType.setUnknown();
                        gIdNumber.assign("");
                        gPhoneNumber.assign("");
                        gStreet1.assign("");
                        gStreet2.assign("");
                        gCity.assign("");
                        gState.assign("");
                        gZip.assign("");
                        gCountry.assign("");
                        
                        OnPhrase[] onPhrase3 = new OnPhrase[]
                        {
                           new OnPhrase(Condition.ERROR, Action.LEAVE, "addGuest"),
                           new OnPhrase(Condition.ENDKEY, Action.LEAVE, "addGuest")
                        };
                        
                        repeat("uGuest", onPhrase3, new Block((Body) () -> 
                        {
                           FrameElement[] elementList4 = new FrameElement[]
                           {
                              new Element(gFN, fGuestFrame.widgetGFN()),
                              new Element(gLN, fGuestFrame.widgetGLN()),
                              new Element(gDob, fGuestFrame.widgetGDob()),
                              new Element(gPhoneNumber, fGuestFrame.widgetGPhoneNumber())
                           };
                           
                           fGuestFrame.display(elementList4);
                           
                           FrameElement[] elementList5 = new FrameElement[]
                           {
                              new Element(gIdType, fGuestFrame.widgetGIdType()),
                              new Element(gIdNumber, fGuestFrame.widgetGIdNumber())
                           };
                           
                           fGuestFrame.update(elementList5);
                           
                           OnPhrase[] onPhrase4 = new OnPhrase[]
                           {
                              new OnPhrase(Condition.ENDKEY, Action.RETRY, "uGuest")
                           };
                           
                           repeat("uGuest1", onPhrase4, new Block((Body) () -> 
                           {
                              FrameElement[] elementList6 = new FrameElement[]
                              {
                                 new Element(gStreet1, fGuestFrame.widgetGStreet1()),
                                 new Element(gStreet2, fGuestFrame.widgetGStreet2()),
                                 new Element(gCity, fGuestFrame.widgetGCity()),
                                 new Element(gState, fGuestFrame.widgetGState()),
                                 new Element(gZip, fGuestFrame.widgetGZip()),
                                 new Element(gCountry, fGuestFrame.widgetGCountry())
                              };
                              
                              fGuestFrame.display(elementList6);
                              
                              FrameElement[] elementList7 = new FrameElement[]
                              {
                                 new Element(gFN, fGuestFrame.widgetGFN()),
                                 new Element(gLN, fGuestFrame.widgetGLN()),
                                 new Element(gDob, fGuestFrame.widgetGDob()),
                                 new Element(gPhoneNumber, fGuestFrame.widgetGPhoneNumber())
                              };
                              
                              fGuestFrame.update(elementList7);
                              
                              OnPhrase[] onPhrase5 = new OnPhrase[]
                              {
                                 new OnPhrase(Condition.ENDKEY, Action.LEAVE, "uGuest2")
                              };
                              
                              repeat(TransactionType.FULL, "uGuest2", onPhrase5, new Block((Body) () -> 
                              {
                                 FrameElement[] elementList8 = new FrameElement[]
                                 {
                                    new Element(gStreet1, fGuestFrame.widgetGStreet1()),
                                    new Element(gStreet2, fGuestFrame.widgetGStreet2()),
                                    new Element(gCity, fGuestFrame.widgetGCity()),
                                    new Element(gState, fGuestFrame.widgetGState()),
                                    new Element(gZip, fGuestFrame.widgetGZip()),
                                    new Element(gCountry, fGuestFrame.widgetGCountry())
                                 };
                                 
                                 fGuestFrame.update(elementList8);
                                 
                                 bGuest.setIdType(gIdType);
                                 bGuest.setIdNumber(gIdNumber);
                                 bGuest.setFirstName(gFN);
                                 bGuest.setLastName(gLN);
                                 bGuest.setDateOfBirth(gDob);
                                 bGuest.setPhoneNumber(gPhoneNumber);
                                 bGuest.setStreet1(gStreet1);
                                 bGuest.setStreet2(gStreet2);
                                 bGuest.setCity(gCity);
                                 bGuest.setState(gState);
                                 bGuest.setZip(gZip);
                                 bGuest.setCountry(gCountry);
                                 leave("uGuest");
                              }));
                           }));
                        }));
                     }));
                     
                     ErrorManager.silentErrorEnable();
                     new FindQuery(guest, "guest.guestId = ?", null, "guest.guestId asc", new Object[]
                     {
                        gId
                     }, LockType.NONE).unique();
                     ErrorManager.silentErrorDisable();
                     query0.repositionByID(guest.rowID());
                     query0.next();
                     ControlFlowOps.invoke("refresh");
                  }
                  break;
               case "U":
                  {
                     if (guest._available())
                     {
                        OnPhrase[] onPhrase6 = new OnPhrase[]
                        {
                           new OnPhrase(Condition.ERROR, Action.LEAVE, "uGuest"),
                           new OnPhrase(Condition.ENDKEY, Action.LEAVE, "uGuest")
                        };
                        
                        repeat(TransactionType.FULL, "uGuest", onPhrase6, new Block((Body) () -> 
                        {
                           new FindQuery(bGuest, "bGuest.guestId = ?", null, "bGuest.guestId asc", new Object[]
                           {
                              (P2JQuery.Parameter) () -> guest.getGuestId()
                           }, LockType.EXCLUSIVE).unique();
                           gIdType.assign(bGuest.getIdType());
                           
                           if (_isUnknown(gIdType))
                           {
                              gIdType.assign(1);
                           }
                           
                           FrameElement[] elementList9 = new FrameElement[]
                           {
                              new Element(gFN, fGuestFrame.widgetGFN()),
                              new Element(gLN, fGuestFrame.widgetGLN()),
                              new Element(gDob, fGuestFrame.widgetGDob()),
                              new Element(gPhoneNumber, fGuestFrame.widgetGPhoneNumber())
                           };
                           
                           fGuestFrame.display(elementList9);
                           
                           FrameElement[] elementList10 = new FrameElement[]
                           {
                              new Element(gIdType, fGuestFrame.widgetGIdType()),
                              new Element(gIdNumber, fGuestFrame.widgetGIdNumber())
                           };
                           
                           fGuestFrame.update(elementList10);
                           
                           OnPhrase[] onPhrase7 = new OnPhrase[]
                           {
                              new OnPhrase(Condition.ENDKEY, Action.RETRY, "uGuest")
                           };
                           
                           repeat("uGuest1", onPhrase7, new Block((Body) () -> 
                           {
                              FrameElement[] elementList11 = new FrameElement[]
                              {
                                 new Element(gStreet1, fGuestFrame.widgetGStreet1()),
                                 new Element(gStreet2, fGuestFrame.widgetGStreet2()),
                                 new Element(gCity, fGuestFrame.widgetGCity()),
                                 new Element(gState, fGuestFrame.widgetGState()),
                                 new Element(gZip, fGuestFrame.widgetGZip()),
                                 new Element(gCountry, fGuestFrame.widgetGCountry())
                              };
                              
                              fGuestFrame.display(elementList11);
                              
                              FrameElement[] elementList12 = new FrameElement[]
                              {
                                 new Element(gFN, fGuestFrame.widgetGFN()),
                                 new Element(gLN, fGuestFrame.widgetGLN()),
                                 new Element(gDob, fGuestFrame.widgetGDob()),
                                 new Element(gPhoneNumber, fGuestFrame.widgetGPhoneNumber())
                              };
                              
                              fGuestFrame.update(elementList12);
                              
                              OnPhrase[] onPhrase8 = new OnPhrase[]
                              {
                                 new OnPhrase(Condition.ENDKEY, Action.LEAVE, "uGuest2")
                              };
                              
                              repeat(TransactionType.FULL, "uGuest2", onPhrase8, new Block((Body) () -> 
                              {
                                 FrameElement[] elementList13 = new FrameElement[]
                                 {
                                    new Element(gStreet1, fGuestFrame.widgetGStreet1()),
                                    new Element(gStreet2, fGuestFrame.widgetGStreet2()),
                                    new Element(gCity, fGuestFrame.widgetGCity()),
                                    new Element(gState, fGuestFrame.widgetGState()),
                                    new Element(gZip, fGuestFrame.widgetGZip()),
                                    new Element(gCountry, fGuestFrame.widgetGCountry())
                                 };
                                 
                                 fGuestFrame.update(elementList13);
                                 
                                 bGuest.setIdType(gIdType);
                                 bGuest.setIdNumber(gIdNumber);
                                 bGuest.setFirstName(gFN);
                                 bGuest.setLastName(gLN);
                                 bGuest.setDateOfBirth(gDob);
                                 bGuest.setPhoneNumber(gPhoneNumber);
                                 bGuest.setStreet1(gStreet1);
                                 bGuest.setStreet2(gStreet2);
                                 bGuest.setCity(gCity);
                                 bGuest.setState(gState);
                                 bGuest.setZip(gZip);
                                 bGuest.setCountry(gCountry);
                                 leave("uGuest");
                              }));
                           }));
                        }));
                     }
                     ControlFlowOps.invoke("refresh");
                  }
                  break;
               case "R":
                  {
                     NamedEventManager.publish("pop-program", thisProcedure());
                     leave("proc");
                  }
               default:
                  {
                     if (_notUnknown(selection))
                     {
                        message("Invalid selection - try again");
                        selection.setUnknown();
                        pause();
                        next("proc");
                     }
                  }
                  break;
            }
            selection.assign("R");
            
            OnPhrase[] onPhrase9 = new OnPhrase[]
            {
               new OnPhrase(Condition.ENDKEY, Action.LEAVE, "choice")
            };
            
            repeat("choice", onPhrase9, new Block((Body) () -> 
            {
               hideMessage(true);
               
               message("(P)rev   (N)ext   (F)irst   (L)ast");
               message("F(i)nd   (A)dd   (U)pdate   (D)elete   (R)eturn", false, new AccessorWrapper(selection), true, "x(1)");
               selection.assign(toUpperCase(selection));
               leave("choice");
            }));
         }));
      }));
   }

   public void refresh()
   {
      internalProcedure(new Block((Body) () -> 
      {
         if (_not(guest.available()))
         {
            fGuestFrame.clearAll(true);
            returnNormal();
         }
         
         gId.assign(guest.getGuestId());
         gFN.assign(guest.getFirstName());
         gLN.assign(guest.getLastName());
         gDob.assign(guest.getDateOfBirth());
         gIdType.assign(guest.getIdType());
         gIdNumber.assign(guest.getIdNumber());
         gPhoneNumber.assign(guest.getPhoneNumber());
         gStreet1.assign(guest.getStreet1());
         gStreet2.assign(guest.getStreet2());
         gCity.assign(guest.getCity());
         gState.assign(guest.getState());
         gZip.assign(guest.getZip());
         gCountry.assign(guest.getCountry());
         
         FrameElement[] elementList0 = new FrameElement[]
         {
            new Element(gId, fGuestFrame.widgetGId()),
            new Element(gFN, fGuestFrame.widgetGFN()),
            new Element(gLN, fGuestFrame.widgetGLN()),
            new Element(gDob, fGuestFrame.widgetGDob()),
            new Element(gIdType, fGuestFrame.widgetGIdType()),
            new Element(gIdNumber, fGuestFrame.widgetGIdNumber()),
            new Element(gPhoneNumber, fGuestFrame.widgetGPhoneNumber()),
            new Element(gStreet1, fGuestFrame.widgetGStreet1()),
            new Element(gStreet2, fGuestFrame.widgetGStreet2()),
            new Element(gCity, fGuestFrame.widgetGCity()),
            new Element(gState, fGuestFrame.widgetGState()),
            new Element(gZip, fGuestFrame.widgetGZip()),
            new Element(gCountry, fGuestFrame.widgetGCountry())
         };
         
         fGuestFrame.display(elementList0);
      }));
   }
}
