package com.goldencode.hotel;

import com.goldencode.p2j.util.*;
import com.goldencode.hotel.ui.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.hotel.dmo.hotel.*;
import com.goldencode.util.*;
import com.goldencode.p2j.persist.lock.*;
import java.util.function.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.SQLHelper.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;
import static com.goldencode.p2j.util.ArrayAssigner.*;
import static com.goldencode.p2j.util.character.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in reservations.p).
 */
public class Reservations
{
   public static final String FMT_STR_1 = "99/99/99";

   public static final String FMT_STR_2 = ">,>>>,>>9";

   public static final String FMT_STR_3 = ">>9.99%";

   public static final String FMT_STR_4 = "x(1)";

   public static final String FMT_STR_5 = "x(11)";

   public static final String FMT_STR_6 = "x(25)";

   public static final String FMT_STR_7 = "(999)999-9999";

   public static final String FMT_STR_8 = ">>9";

   public static final String FMT_STR_9 = "x(15)";

   Rate.Buf bRate = RecordBuffer.define(Rate.Buf.class, "hotel", "bRate", "b-rate");

   Room.Buf bRoom = RecordBuffer.define(Room.Buf.class, "hotel", "bRoom", "b-room");

   Reservation.Buf bRes2 = RecordBuffer.define(Reservation.Buf.class, "hotel", "bRes2", "b-res2");

   Reservation.Buf bRes = RecordBuffer.define(Reservation.Buf.class, "hotel", "bRes", "b-res");

   Checkout.Buf bOut = RecordBuffer.define(Checkout.Buf.class, "hotel", "bOut", "b-out");

   CheckoutRooms.Buf bOutRoom = RecordBuffer.define(CheckoutRooms.Buf.class, "hotel", "bOutRoom", "b-out-room");

   CheckoutRooms.Buf bOutRoom2 = RecordBuffer.define(CheckoutRooms.Buf.class, "hotel", "bOutRoom2", "b-out-room2");

   Guest.Buf bGuest = RecordBuffer.define(Guest.Buf.class, "hotel", "bGuest", "b-guest");

   ReservationRooms.Buf bResRoom = RecordBuffer.define(ReservationRooms.Buf.class, "hotel", "bResRoom", "b-res-room");

   Reservation.Buf reservation = RecordBuffer.define(Reservation.Buf.class, "hotel", "reservation", "reservation");

   Room.Buf room = RecordBuffer.define(Room.Buf.class, "hotel", "room", "room");

   ReservationsFResRoom fResRoomFrame = GenericFrame.createFrame(ReservationsFResRoom.class, "f-res-room");

   ReservationsFResSearch fResSearchFrame = GenericFrame.createFrame(ReservationsFResSearch.class, "f-res-search");

   ReservationsFGuests fGuestsFrame = GenericFrame.createFrame(ReservationsFGuests.class, "f-guests");

   ReservationsFResRooms fResRoomsFrame = GenericFrame.createFrame(ReservationsFResRooms.class, "f-res-rooms");

   ReservationsFRes fResFrame = GenericFrame.createFrame(ReservationsFRes.class, "f-res");

   ReservationsFMainHeader fMainHeaderFrame = GenericFrame.createFrame(ReservationsFMainHeader.class, "f-main-header");

   ReservationsFRoomGuests fRoomGuestsFrame = GenericFrame.createFrame(ReservationsFRoomGuests.class, "f-room-guests");

   logical progStarted = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "prog-started", new logical(false));

   character uName = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "u-name", new character(""));

   character screenTitle = SharedVariableManager.lookupVariable("screen-title", character.class);

   character[] roomTypes = SharedVariableManager.lookupVariable("room-types", character.class, 5);

   character[] resStateCh = SharedVariableManager.lookupVariable("res-state-ch", character.class, 4);

   integer resStatePlaced = SharedVariableManager.lookupVariable("res-state-placed", integer.class);

   integer resStateCanceled = SharedVariableManager.lookupVariable("res-state-canceled", integer.class);

   final QueryWrapper query0 = new QueryWrapper("q-guest", true);

   date rCheckin = UndoableFactory.date();

   date rCheckout = UndoableFactory.date();

   integer rId = UndoableFactory.integer((long) 0);

   decimal rDiscount = UndoableFactory.decimal(new decimal(0));

   character rState = UndoableFactory.character();

   character rStateName = UndoableFactory.character();

   integer gId = UndoableFactory.integer((long) 0);

   character gFN = UndoableFactory.character("");

   character gLN = UndoableFactory.character("");

   date gDob = UndoableFactory.date();

   character gPhoneNumber = UndoableFactory.character("");

   integer rRooms = UndoableFactory.integer((long) 0);

   character rType = UndoableFactory.character();

   final QueryWrapper query1 = new QueryWrapper("q-res", true);

   ReservationsChooseGuestFAddGuest chooseGuestFAddGuestFrame = null;

   ReservationsChooseGuestFSearch chooseGuestFSearchFrame = null;

   final QueryWrapper query8 = new QueryWrapper("q-rs-room", false);

   /**
    * External procedure (converted to Java from the 4GL source code
    * in reservations.p).
    */
   public void execute()
   {
      character hTime = UndoableFactory.character();
      character sprog = UndoableFactory.character(null);
      character selection = UndoableFactory.character(null);
      character[] guestNames = UndoableFactory.characterExtent(4);
      logical rDel = UndoableFactory.logical();
      integer rRType = UndoableFactory.integer((long) 0);
      integer resRooms = UndoableFactory.integer();
      integer totalRooms = UndoableFactory.integer();
      logical lRAdd = UndoableFactory.logical();
      integer ridx = UndoableFactory.integer();
      logical rOk = UndoableFactory.logical();
      logical lResCancel = UndoableFactory.logical();
      logical lResDel = UndoableFactory.logical();
      
      externalProcedure(Reservations.this, new Block((Init) () -> 
      {
         rDiscount.setPrecision(2);
      }, 
      (Body) () -> 
      {
         fResRoomFrame.widgetRRooms().setValidation(((ValidationExpr<integer>) (integer rRooms_) -> isGreaterThan(rRooms_, 0)), "Must set no. of rooms!");
         fResFrame.widgetRCheckout().setValidation(((ValidationExpr<date>) (date rCheckout_) -> isGreaterThan(rCheckout_, rCheckin)), ((ValidationMsg<date>) (date rCheckout_) -> concat("Checkout must be greater than", valueOf(rCheckin))));
         fResFrame.widgetRCheckin().setValidation(((ValidationExpr<date>) (date rCheckin_) -> isGreaterThanOrEqual(rCheckin_, date.today())), ((ValidationMsg<date>) (date rCheckin_) -> concat("Checkin must be greater or equal than ", valueOf(date.today()))));
         query0.addBuffer(bGuest, true);
         query1.addBuffer(reservation, true);
         fMainHeaderFrame.openScope();
         fResFrame.openScope();
         fResRoomsFrame.openScope();
         fGuestsFrame.openScope();
         fRoomGuestsFrame.openScope();
         RecordBuffer.openScope(bRes, bOutRoom, bGuest, bResRoom, reservation);
         progStarted.assign(true);
         screenTitle.assign("Reservations");
         
         FrameElement[] elementList0 = new FrameElement[]
         {
            new Element(new FieldReference(bGuest, "guestId"), fGuestsFrame.widgetBrwsGuestGuestIdColumn()),
            new Element(new FieldReference(bGuest, "firstName"), fGuestsFrame.widgetBrwsGuestFirstNameColumn()),
            new Element(new FieldReference(bGuest, "lastName"), fGuestsFrame.widgetBrwsGuestLastNameColumn()),
            new Element(new FieldReference(bGuest, "dateOfBirth"), fGuestsFrame.widgetBrwsGuestDateOfBirthColumn())
         };
         fGuestsFrame.widgetBrwsGuest().registerQuery(query0, elementList0);
         fResRoomsFrame.asWidget().setFrameHandle(fResFrame.asWidgetHandle());
         fResRoomsFrame.setColumn(new decimal(new integer(40)));
         fResRoomsFrame.setRow(new decimal(new integer(5)));
         query1.assign(new AdaptiveQuery().initialize(reservation, "upper(reservation.state) != 'C'", null, "reservation.checkin asc", LockType.NONE));
         query1.open();
         
         EventList list0 = new EventList();
         list0.addEvent("leave", fRoomGuestsFrame.widgetGuestIdsArray0());
         list0.addEvent("leave", fRoomGuestsFrame.widgetGuestIdsArray1());
         list0.addEvent("leave", fRoomGuestsFrame.widgetGuestIdsArray2());
         list0.addEvent("leave", fRoomGuestsFrame.widgetGuestIdsArray3());
         
         registerTrigger(list0, TriggerBlock0.class, Reservations.this);
         
         registerTrigger(new EventList("return", fResFrame.widgetGId()), Reservations.this, new Trigger((Body) () -> 
         {
            if (_isEqual(fResFrame.widgetGId().getScreenValue(), "?"))
            {
               ControlFlowOps.invokeWithMode("choose-guest", "O", gId);
               
               FrameElement[] elementList7 = new FrameElement[]
               {
                  new Element(gId, fResFrame.widgetGId())
               };
               
               fResFrame.display(elementList7);
               
               gFN.assign("");
               gLN.assign("");
               gDob.setUnknown();
               returnConsume();
            }
         }));
         
         query1.first();
         
         if (reservation._available())
         {
            rId.assign(reservation.getReservationId());
         }
         
         ControlFlowOps.invoke("refresh");
         
         repeat("proc", new Block((Init) () -> 
         {
            fResSearchFrame.openScope();
            RecordBuffer.openScope(bOut);
         }, 
         (Body) () -> 
         {
            if (_or(isUnknown(uName), () -> isEqual(uName, "")))
            {
               messageBox("You are not logged in - access denied", ALERT_MESSAGE, BTN_OK, (String) null);
               quit();
            }
            
            hTime.assign(valueOf(datetimetz.now(), "99/99/99 HH:MM:SS"));
            hTime.assign(substring(hTime, 10));
            
            doBlock("blockLabel1", new Block((Body) () -> 
            {
               fMainHeaderFrame.widgetUName().setColumn(new decimal(new integer(1)));
               fMainHeaderFrame.widgetScreenTitle().setColumn(plus(plus(fMainHeaderFrame.widgetUName().getColumn(), length(uName)), divide(minus(minus(minus(fMainHeaderFrame.getWidthChars(), length(uName)), length(screenTitle)), length(hTime)), 2)));
               fMainHeaderFrame.widgetHTime().setColumn(minus(fMainHeaderFrame.getWidthChars(), length(hTime)));
               fMainHeaderFrame.widgetScreenTitle().setFormat(concat("x(", valueOf(length(screenTitle)), ")"));
            }));
            
            FrameElement[] elementList8 = new FrameElement[]
            {
               new Element(uName, fMainHeaderFrame.widgetUName()),
               new Element(screenTitle, fMainHeaderFrame.widgetScreenTitle()),
               new Element(hTime, fMainHeaderFrame.widgetHTime())
            };
            
            fMainHeaderFrame.display(elementList8);
            
            sprog.setUnknown();
            
            switch (StringHelper.safeTrimTrailing((selection).toStringMessage()).toUpperCase())
            {
               case "P":
                  {
                     query1.previous();
                     
                     if (_not(reservation.available()))
                     {
                        query1.first();
                     }
                     
                     if (reservation._available())
                     {
                        rId.assign(reservation.getReservationId());
                        ControlFlowOps.invoke("refresh");
                     }
                  }
                  break;
               case "N":
                  {
                     query1.next();
                     
                     if (_not(reservation.available()))
                     {
                        query1.last();
                     }
                     
                     if (reservation._available())
                     {
                        rId.assign(reservation.getReservationId());
                        ControlFlowOps.invoke("refresh");
                     }
                  }
                  break;
               case "F":
                  {
                     query1.first();
                     
                     if (reservation._available())
                     {
                        rId.assign(reservation.getReservationId());
                        ControlFlowOps.invoke("refresh");
                     }
                  }
                  break;
               case "L":
                  {
                     query1.last();
                     
                     if (reservation._available())
                     {
                        rId.assign(reservation.getReservationId());
                        ControlFlowOps.invoke("refresh");
                     }
                  }
                  break;
               case "I":
                  {
                     registerTrigger(new EventList("choose", fResSearchFrame.widgetBtnCancel()), Reservations.this, new Trigger((Body) () -> 
                     {
                        fResSearchFrame.apply("f4");
                     }));
                     
                     registerTrigger(new EventList("choose", fResSearchFrame.widgetBtnOk()), Reservations.this, new Trigger((Body) () -> 
                     {
                        fResSearchFrame.apply("go");
                     }));
                     
                     OnPhrase[] onPhrase2 = new OnPhrase[]
                     {
                        new OnPhrase(Condition.ENDKEY, Action.LEAVE, "gSearch")
                     };
                     
                     repeat("gSearch", onPhrase2, new Block((Body) () -> 
                     {
                        gFN.assign("");
                        gLN.assign("");
                        gDob.setUnknown();
                        
                        FrameElement[] elementList9 = new FrameElement[]
                        {
                           new Element(gFN, fResSearchFrame.widgetGFN()),
                           new Element(gLN, fResSearchFrame.widgetGLN()),
                           new Element(gDob, fResSearchFrame.widgetGDob()),
                           new WidgetElement(fResSearchFrame.widgetBtnOk()),
                           new WidgetElement(fResSearchFrame.widgetBtnCancel())
                        };
                        
                        fResSearchFrame.update(elementList9);
                        
                        if (_and(and(isEqual(gFN, ""), () -> isEqual(gLN, "")), () -> isUnknown(gDob)))
                        {
                           message("Enter at least one search criteria!");
                           next("gSearch");
                        }
                        
                        CompoundQuery query4 = new CompoundQuery();
                        
                        forEach("loopLabel2", new Block((Init) () -> 
                        {
                           query4.initialize(false, false);
                           query4.addComponent(new AdaptiveQuery().initialize(bGuest, "case when ? then true else upper(bGuest.firstName) like ? end and case when ? then true else upper(bGuest.lastName) like ? end and case when ? then true else bGuest.dateOfBirth = ? end", null, "bGuest.guestId asc", new Object[]
                           {
                              or(isUnknown(gFN), () -> isEqual(gFN, "")),
                              toUpperCase(convertToSQLLike(concat(gFN, "*"), false)),
                              or(isUnknown(gLN), () -> isEqual(gLN, "")),
                              toUpperCase(convertToSQLLike(concat(gLN, "*"), false)),
                              isUnknown(gDob),
                              gDob
                           }, LockType.NONE));
                           query4.addComponent(new RandomAccessQuery().initialize(bRes, "bRes.guestId = ? and bRes.checkout >= ?", null, "bRes.checkin asc", new Object[]
                           {
                              new FieldReference(bGuest, "guestId"),
                              (DateExpr) () -> date.today()
                           }), QueryConstants.FIRST);
                        }, 
                        (Body) () -> 
                        {
                           query4.iterate();
                           rId.assign(bRes.getReservationId());
                           leave("loopLabel2");
                        }));
                        
                        leave("gSearch");
                     }));
                     
                     fResSearchFrame.hide(true);
                     
                     ErrorManager.silentErrorEnable();
                     new FindQuery(reservation, "reservation.reservationId = ?", null, "reservation.reservationId asc", new Object[]
                     {
                        rId
                     }, LockType.NONE).unique();
                     ErrorManager.silentErrorDisable();
                     
                     if (reservation._available())
                     {
                        query1.repositionByID(reservation.rowID());
                        query1.next();
                        ControlFlowOps.invoke("refresh");
                     }
                  }
                  break;
               case "A":
                  {
                     rId.assign((reservation._available() ? reservation.getReservationId() : new integer()));
                     
                     OnPhrase[] onPhrase3 = new OnPhrase[]
                     {
                        new OnPhrase(Condition.ERROR, Action.LEAVE, "addRes"),
                        new OnPhrase(Condition.ENDKEY, Action.LEAVE, "addRes")
                     };
                     
                     repeat(TransactionType.FULL, "addRes", onPhrase3, new Block((Body) () -> 
                     {
                        OnPhrase[] onPhrase4 = new OnPhrase[]
                        {
                           new OnPhrase(Condition.ERROR, Action.NEXT, "createRes")
                        };
                        
                        repeat(TransactionType.FULL, "createRes", onPhrase4, new Block((Body) () -> 
                        {
                           ErrorManager.silentErrorEnable();
                           new FindQuery(bRes, (String) null, null, "bRes.reservationId asc", LockType.NONE).last();
                           ErrorManager.silentErrorDisable();
                           rId.assign((bRes._available() ? plus(bRes.getReservationId(), 1) : new int64(1)));
                           bRes.release();
                           bRes.create();
                           bRes.setReservationId(rId);
                           leave("createRes");
                        }));
                        
                        fResFrame.clearAll(false);
                        fResRoomsFrame.clearAll(false);
                        
                        FrameElement[] elementList10 = new FrameElement[]
                        {
                           new Element(rId, fResFrame.widgetRId())
                        };
                        
                        fResFrame.display(elementList10);
                        
                        rDel.assign(true);
                        rCheckin.setUnknown();
                        rCheckout.setUnknown();
                        
                        OnPhrase[] onPhrase5 = new OnPhrase[]
                        {
                           new OnPhrase(Condition.ENDKEY, Action.LEAVE, "addRes"),
                           new OnPhrase(Condition.ERROR, Action.LEAVE, "addRes")
                        };
                        
                        repeat(TransactionType.FULL, "updateRes", onPhrase5, new Block((Init) () -> 
                        {
                           fResRoomFrame.openScope();
                        }, 
                        (Body) () -> 
                        {
                           FrameElement[] elementList11 = new FrameElement[]
                           {
                              new Element(rCheckin, fResFrame.widgetRCheckin())
                           };
                           
                           fResFrame.update(elementList11);
                           
                           FrameElement[] elementList12 = new FrameElement[]
                           {
                              new Element(rCheckout, fResFrame.widgetRCheckout())
                           };
                           
                           fResFrame.update(elementList12);
                           
                           bRes.setCheckin(rCheckin);
                           bRes.setCheckout(rCheckout);
                           
                           OnPhrase[] onPhrase6 = new OnPhrase[]
                           {
                              new OnPhrase(Condition.ENDKEY, Action.NEXT, "loopLabel3", "updateRes"),
                              new OnPhrase(Condition.ERROR, Action.NEXT, "loopLabel3", "updateRes")
                           };
                           
                           repeat(TransactionType.FULL, "loopLabel3", onPhrase6, new Block((Body) () -> 
                           {
                              FrameElement[] elementList13 = new FrameElement[]
                              {
                                 new Element(rDiscount, fResFrame.widgetRDiscount())
                              };
                              
                              fResFrame.update(elementList13);
                              
                              bRes.setDiscount(rDiscount);
                              leave("loopLabel3");
                           }));
                           
                           bRes.setState(subscript(resStateCh, resStatePlaced));
                           
                           FrameElement[] elementList14 = new FrameElement[]
                           {
                              new Element(subscript(resStateCh, resStatePlaced), fResFrame.widgetRState())
                           };
                           
                           fResFrame.display(elementList14);
                           
                           OnPhrase[] onPhrase7 = new OnPhrase[]
                           {
                              new OnPhrase(Condition.ENDKEY, Action.NEXT, "updateRes")
                           };
                           
                           repeat(TransactionType.FULL, "selGuest", onPhrase7, new Block((Body) () -> 
                           {
                              gFN.assign("");
                              gLN.assign("");
                              gDob.setUnknown();
                              gId.setUnknown();
                              
                              FrameElement[] elementList15 = new FrameElement[]
                              {
                                 new Element(gId, fResFrame.widgetGId())
                              };
                              
                              fResFrame.update(elementList15);
                              
                              ErrorManager.silentErrorEnable();
                              new FindQuery(bGuest, "bGuest.guestId = ?", null, "bGuest.guestId asc", new Object[]
                              {
                                 gId
                              }, LockType.NONE).unique();
                              ErrorManager.silentErrorDisable();
                              
                              if (bGuest._available())
                              {
                                 gFN.assign(bGuest.getFirstName());
                                 gLN.assign(bGuest.getLastName());
                                 gDob.assign(bGuest.getDateOfBirth());
                                 gPhoneNumber.assign(bGuest.getPhoneNumber());
                                 
                                 FrameElement[] elementList16 = new FrameElement[]
                                 {
                                    new Element(gFN, fResFrame.widgetGFN()),
                                    new Element(gLN, fResFrame.widgetGLN()),
                                    new Element(gDob, fResFrame.widgetGDob()),
                                    new Element(gPhoneNumber, fResFrame.widgetGPhoneNumber())
                                 };
                                 
                                 fResFrame.display(elementList16);
                                 
                                 bRes.setGuestId(gId);
                                 leave("selGuest");
                              }
                              else
                              {
                                 messageBox("Guest not found!", ALERT_MESSAGE, BTN_OK, (String) null);
                              }
                           }));
                           
                           ControlFlowOps.invokeWithMode("set-room-types-combo", "I", fResRoomFrame.widgetRRType().asWidgetHandle());
                           
                           OnPhrase[] onPhrase8 = new OnPhrase[]
                           {
                              new OnPhrase(Condition.ENDKEY, Action.NEXT, "updateRes")
                           };
                           
                           repeat(TransactionType.FULL, "loopLabel4", onPhrase8, new Block((Body) () -> 
                           {
                              rRType.assign(1);
                              
                              FrameElement[] elementList17 = new FrameElement[]
                              {
                                 new Element(rRType, fResRoomFrame.widgetRRType()),
                                 new Element(rRooms, fResRoomFrame.widgetRRooms())
                              };
                              
                              fResRoomFrame.update(elementList17);
                              
                              resRooms.assign(0);
                              totalRooms.assign(0);
                              
                              AdaptiveQuery query5 = new AdaptiveQuery();
                              
                              forEach("loopLabel5", new Block((Init) () -> 
                              {
                                 RecordBuffer.openScope(room);
                                 query5.initialize(room, "room.typeOfRoom = ?", null, "room.roomNumber asc", new Object[]
                                 {
                                    rRType
                                 }, LockType.NONE);
                              }, 
                              (Body) () -> 
                              {
                                 query5.next();
                                 totalRooms.assign(plus(totalRooms, 1));
                              }));
                              
                              AdaptiveQuery query6 = new AdaptiveQuery();
                              
                              forEach("loopLabel6", new Block((Init) () -> 
                              {
                                 RecordBuffer.openScope(bRes2);
                                 query6.initialize(bRes2, "bRes2.checkin >= ? and bRes2.checkout <= ? and upper(bRes2.state) != ?", null, "bRes2.checkin asc", new Object[]
                                 {
                                    rCheckin,
                                    rCheckin,
                                    toUpperCase(subscript(resStateCh, resStateCanceled))
                                 }, LockType.NONE);
                              }, 
                              (Body) () -> 
                              {
                                 query6.next();
                                 resRooms.assign(plus(resRooms, 1));
                              }));
                              
                              if (_isLessThanOrEqual(minus(totalRooms, resRooms), 0))
                              {
                                 messageBox(new Object[]
                                 {
                                    concat("No available [", subscript(roomTypes, rRType), "] rooms for ", valueOf(rCheckin)),
                                    concat(" - ", valueOf(rCheckout), new character("!"))
                                 }, ALERT_MESSAGE, BTN_OK, (String) null);
                                 undoRetry("loopLabel4");
                              }
                              
                              bResRoom.create();
                              bResRoom.setReservationId(rId);
                              bResRoom.setRooms(rRooms);
                              bResRoom.setTypeOfRoom(rRType);
                              bResRoom.release();
                              ControlFlowOps.invoke("refresh");
                              messageBox("Add another?", false, new AccessorWrapper(lRAdd), ALERT_MESSAGE, BTN_YES_NO, (String) null);
                              
                              if (_not(lRAdd))
                              {
                                 leave("loopLabel4");
                              }
                           }));
                           
                           rDel.assign(false);
                           leave("updateRes");
                        }));
                        
                        if ((rDel).booleanValue())
                        {
                           undoLeave("addRes");
                        }
                        else
                        {
                           leave("addRes");
                        }
                     }));
                     
                     ErrorManager.silentErrorEnable();
                     new FindQuery(reservation, "reservation.reservationId = ?", null, "reservation.reservationId asc", new Object[]
                     {
                        rId
                     }, LockType.NONE).unique();
                     ErrorManager.silentErrorDisable();
                     ControlFlowOps.invoke("refresh");
                  }
                  break;
               case "K":
                  {
                     /*
                                 checkin, create the records with:
                                 - reservation: set the state to "checked in"
                                 - checkout: 
                                 - checkout-rooms: 
                                       set the room numbers for each room
                                       set the guest-id's for each room (one or more)
                               */
                     if (_isNotEqual(reservation.getState(), "P"))
                     {
                        messageBox("Reservation must be in (P)laced state", ALERT_MESSAGE, BTN_OK, (String) null);
                     }
                     else
                     {
                        OnPhrase[] onPhrase9 = new OnPhrase[]
                        {
                           new OnPhrase(Condition.ERROR, Action.LEAVE, "rCheckin"),
                           new OnPhrase(Condition.ENDKEY, Action.LEAVE, "rCheckin")
                        };
                        
                        doBlock(TransactionType.FULL, "rCheckin", onPhrase9, new Block((Body) () -> 
                        {
                           new FindQuery(bRes, "bRes.reservationId = ?", null, "bRes.reservationId asc", new Object[]
                           {
                              rId
                           }, LockType.EXCLUSIVE).unique();
                           bRes.setState(new character("I"));
                           bOut.create();
                           bOut.setReservationId(bRes.getReservationId());
                           bOut.setState(new character("I"));
                           bOut.setRoomCharges(new integer(0));
                           bOut.setSalesTax(new integer(0));
                           bOut.setTotal(new integer(0));
                           
                           AdaptiveQuery query7 = new AdaptiveQuery();
                           
                           forEach("loopLabel7", new Block((Init) () -> 
                           {
                              RecordBuffer.openScope(bRoom);
                              query7.initialize(bResRoom, "bResRoom.reservationId = ?", null, "bResRoom.id asc", new Object[]
                              {
                                 (P2JQuery.Parameter) () -> bRes.getReservationId()
                              });
                           }, 
                           (Body) () -> 
                           {
                              query7.next();
                              
                              ToClause toClause0 = new ToClause(ridx, 1, new FieldReference(bResRoom, "rooms"));
                              OnPhrase[] onPhrase10 = new OnPhrase[]
                              {
                                 new OnPhrase(Condition.ERROR, Action.LEAVE, "rCheckin"),
                                 new OnPhrase(Condition.ENDKEY, Action.LEAVE, "rCheckin")
                              };
                              
                              doTo(TransactionType.FULL, "loopLabel8", toClause0, onPhrase10, new Block((Body) () -> 
                              {
                                 bOutRoom.create();
                                 bOutRoom.setReservationId(bRes.getReservationId());
                                 bOutRoom.setRoomCharges(new integer(0));
                                 bOutRoom.setLaundryCharges(new integer(0));
                                 bOutRoom.setMinibarCharges(new integer(0));
                                 query8.assign(new AdaptiveQuery().initialize(bRoom, "bRoom.typeOfRoom = ?", null, "bRoom.roomNumber asc", "WHOLE-INDEX,idx-r-no", new Object[]
                                 {
                                    (P2JQuery.Parameter) () -> bResRoom.getTypeOfRoom()
                                 }));
                                 query8.open();
                                 query8.first();
                                 
                                 rBRoom:
                                 while (bRoom._available())
                                 {
                                    message(new Object[]
                                    {
                                       "checking ",
                                       (integer) new FieldReference(bRoom, "roomNumber").getValue()
                                    });
                                    rOk.assign(true);
                                    
                                    CompoundQuery query9 = new CompoundQuery();
                                    
                                    String[] enclBlocks0 = new String[]
                                    {
                                       "rBRoom"
                                    };
                                    
                                    forEach(enclBlocks0, "loopLabel9", new Block((Init) () -> 
                                    {
                                       RecordBuffer.openScope(bRes2, bOutRoom2);
                                       query9.initialize(false, false);
                                       query9.addComponent(new AdaptiveQuery().initialize(bRes2, "bRes2.checkin >= ? and bRes2.checkin <= ?", null, "bRes2.checkin asc", new Object[]
                                       {
                                          (P2JQuery.Parameter) () -> bRes.getCheckin(),
                                          (P2JQuery.Parameter) () -> bRes.getCheckout()
                                       }, LockType.NONE));
                                       query9.addComponent(new AdaptiveQuery().initialize(bOutRoom2, "bOutRoom2.id != ? and bOutRoom2.roomNumber = ? and bOutRoom2.reservationId = ?", null, "bOutRoom2.roomNumber asc", new Object[]
                                       {
                                          (RecidExpr) () -> bOutRoom.recordID(),
                                          (P2JQuery.Parameter) () -> bRoom.getRoomNumber(),
                                          new FieldReference(bRes2, "reservationId")
                                       }, LockType.NONE));
                                    }, 
                                    (Body) () -> 
                                    {
                                       query9.iterate();
                                       rOk.assign(false);
                                       leave("loopLabel9");
                                    }));
                                    
                                    if (deferredLeave("rBRoom"))
                                       break rBRoom;
                                    if (deferredNext("rBRoom"))
                                       continue rBRoom;
                                    
                                    if ((rOk).booleanValue())
                                    {
                                       break rBRoom;
                                    }
                                    else
                                    {
                                       query8.next();
                                    }
                                 }
                                 
                                 if (_not(bRoom.available()))
                                 {
                                    messageBox(concat("Can't find available room for [", subscript(roomTypes, (integer) new FieldReference(bResRoom, "typeOfRoom").getValue()), new character("] in selected period!")), ALERT_MESSAGE, BTN_OK, (String) null);
                                    undoLeave("rCheckin");
                                 }
                                 
                                 repeat(TransactionType.FULL, "rRate", new Block((Init) () -> 
                                 {
                                    RecordBuffer.openScope(bRate);
                                 }, 
                                 (Body) () -> 
                                 {
                                    bOutRoom.setRoomNumber(bRoom.getRoomNumber());
                                    ErrorManager.silentErrorEnable();
                                    new FindQuery(bRate, "bRate.typeOfRoom = ? and bRate.startDate <= ? and (bRate.endDate is null or bRate.endDate >= ?)", null, "bRate.endDate asc", new Object[]
                                    {
                                       bRoom.getTypeOfRoom(),
                                       (P2JQuery.Parameter) () -> date.today(),
                                       (P2JQuery.Parameter) () -> date.today()
                                    }, LockType.NONE).last();
                                    ErrorManager.silentErrorDisable();
                                    
                                    if (_not(bRate.available()))
                                    {
                                       ErrorManager.silentErrorEnable();
                                       new FindQuery(bRate, "bRate.typeOfRoom = ? and bRate.endDate <= ?", null, "bRate.endDate asc", new Object[]
                                       {
                                          bRoom.getTypeOfRoom(),
                                          (P2JQuery.Parameter) () -> date.today()
                                       }, LockType.NONE).last();
                                       ErrorManager.silentErrorDisable();
                                    }
                                    
                                    if (_not(bRate.available()))
                                    {
                                       message(concat("Can't find rate for room [", subscript(roomTypes, (integer) new FieldReference(bRoom, "typeOfRoom").getValue()), new character("] in booked period!")));
                                       leave("rRate");
                                    }
                                    else
                                    {
                                       bOutRoom.setRoomCharges(multiply(bRate.getRate(), date.differenceNum(bRes.getCheckout(), bRes.getCheckin())));
                                       leave("rRate");
                                    }
                                 }));
                                 
                                 bOut.setRoomCharges(plus(bOut.getRoomCharges(), bOutRoom.getRoomCharges()));
                                 bOutRoom.setGuestIds(new integer(0));
                                 bOutRoom.setGuestIds(0, new integer());
                                 fRoomGuestsFrame.clear(false);
                                 fRoomGuestsFrame.setTitle(concat("Checkin room ", valueOf(bRoom.getRoomNumber()), " [", subscript(roomTypes, bRoom.getTypeOfRoom()), "]"));
                                 
                                 FrameElement[] elementList18 = new FrameElement[]
                                 {
                                    new Element(new FieldReference(bOutRoom, "guestIds", 0), fRoomGuestsFrame.widgetGuestIdsArray0()),
                                    new Element(new FieldReference(bOutRoom, "guestIds", 1), fRoomGuestsFrame.widgetGuestIdsArray1()),
                                    new Element(new FieldReference(bOutRoom, "guestIds", 2), fRoomGuestsFrame.widgetGuestIdsArray2()),
                                    new Element(new FieldReference(bOutRoom, "guestIds", 3), fRoomGuestsFrame.widgetGuestIdsArray3())
                                 };
                                 
                                 fRoomGuestsFrame.update(elementList18);
                              }));
                           }));
                        }));
                     }
                     new FindQuery(reservation, "reservation.reservationId = ?", null, "reservation.reservationId asc", new Object[]
                     {
                        rId
                     }, LockType.NONE).unique();
                     ControlFlowOps.invoke("refresh");
                  }
                  break;
               case "C":
                  {
                     /* cancel the reservation */
                     if (_isEqual(reservation.getState(), "P"))
                     {
                        OnPhrase[] onPhrase11 = new OnPhrase[]
                        {
                           new OnPhrase(Condition.ERROR, Action.LEAVE, "blockLabel2"),
                           new OnPhrase(Condition.ENDKEY, Action.LEAVE, "blockLabel2")
                        };
                        
                        doBlock(TransactionType.FULL, "blockLabel2", onPhrase11, new Block((Body) () -> 
                        {
                           messageBox("Cancel current reservation?", false, new AccessorWrapper(lResCancel), ALERT_MESSAGE, BTN_YES_NO_CANCEL, (String) null);
                           
                           if ((lResCancel).booleanValue())
                           {
                              new FindQuery(bRes, "bRes.reservationId = ?", null, "bRes.reservationId asc", new Object[]
                              {
                                 rId
                              }, LockType.EXCLUSIVE).unique();
                              bRes.setState(new character("C"));
                              bRes.release();
                              ControlFlowOps.invoke("refresh");
                           }
                        }));
                     }
                     else
                     {
                        message("Only processed reservations can be canceled");
                        pause();
                     }
                  }
                  break;
               case "D":
                  {
                     messageBox("Delete current reservation?", false, new AccessorWrapper(lResDel), ALERT_MESSAGE, BTN_YES_NO_CANCEL, (String) null);
                     
                     if ((lResDel).booleanValue())
                     {
                        doBlock(TransactionType.FULL, "blockLabel3", new Block((Body) () -> 
                        {
                           new FindQuery(bRes, "bRes.reservationId = ?", null, "bRes.reservationId asc", new Object[]
                           {
                              rId
                           }, LockType.EXCLUSIVE).unique();
                           
                           PreselectQuery query10 = new PreselectQuery();
                           
                           forEach(TransactionType.FULL, "loopLabel10", new Block((Init) () -> 
                           {
                              query10.initialize(bResRoom, "bResRoom.reservationId = ?", null, "bResRoom.id asc", new Object[]
                              {
                                 (P2JQuery.Parameter) () -> bRes.getReservationId()
                              }, LockType.EXCLUSIVE);
                           }, 
                           (Body) () -> 
                           {
                              query10.next();
                              bResRoom.deleteRecord();
                           }));
                           
                           bRes.deleteRecord();
                           selection.assign("P");
                           next("proc");
                        }));
                     }
                  }
                  break;
               case "R":
                  {
                     NamedEventManager.publish("pop-program", thisProcedure());
                     leave("proc");
                  }
               default:
                  {
                     if (_notUnknown(selection))
                     {
                        message("Invalid selection - try again");
                        selection.setUnknown();
                        pause();
                        next("proc");
                     }
                  }
                  break;
            }
            
            if (_notUnknown(sprog))
            {
               leave("proc");
            }
            
            selection.assign("R");
            
            OnPhrase[] onPhrase12 = new OnPhrase[]
            {
               new OnPhrase(Condition.ENDKEY, Action.LEAVE, "choice")
            };
            
            repeat("choice", onPhrase12, new Block((Body) () -> 
            {
               hideMessage(true);
               
               message("(P)rev   (N)ext   (F)irst   (L)ast");
               message("F(i)nd   (A)dd   (D)elete   Chec(k) in   (C)ancel   (R)eturn", false, new AccessorWrapper(selection), true, "x(1)");
               selection.assign(toUpperCase(selection));
               leave("choice");
            }));
         }));
         
         if (_notUnknown(sprog))
         {
            NamedEventManager.publish("push-program", thisProcedure(), "I", new Object[]
            {
               sprog
            });
         }
      }));
   }

   public void refresh()
   {
      internalProcedure(new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         new FindQuery(reservation, "reservation.reservationId = ?", null, "reservation.reservationId asc", new Object[]
         {
            rId
         }, LockType.NONE).unique();
         ErrorManager.silentErrorDisable();
         
         if (_not(reservation.available()))
         {
            fResFrame.clearAll(false);
            returnNormal();
         }
         
         ErrorManager.silentErrorEnable();
         new FindQuery(bRes, "bRes.id = ?", null, "bRes.reservationId asc", new Object[]
         {
            (P2JQuery.Parameter) () -> reservation.recordID()
         }, LockType.NONE).unique();
         ErrorManager.silentErrorDisable();
         rId.assign(bRes.getReservationId());
         rCheckin.assign(bRes.getCheckin());
         rCheckout.assign(bRes.getCheckout());
         rDiscount.assign(bRes.getDiscount());
         rState.assign(bRes.getState());
         gId.assign(bRes.getGuestId());
         ErrorManager.silentErrorEnable();
         new FindQuery(bGuest, "bGuest.guestId = ?", null, "bGuest.guestId asc", new Object[]
         {
            gId
         }, LockType.NONE).unique();
         ErrorManager.silentErrorDisable();
         
         if (bGuest._available())
         {
            gFN.assign(bGuest.getFirstName());
            gLN.assign(bGuest.getLastName());
            gDob.assign(bGuest.getDateOfBirth());
            gPhoneNumber.assign(bGuest.getPhoneNumber());
         }
         else
         {
            gFN.assign("");
            gLN.assign("");
            gDob.setUnknown();
            gPhoneNumber.assign("");
         }
         
         switch (StringHelper.safeTrimTrailing((rState).toStringMessage()).toUpperCase())
         {
            case "P":
               {
                  rStateName.assign("Placed");
               }
               break;
            case "C":
               {
                  rStateName.assign("Canceled");
               }
               break;
            case "I":
               {
                  rStateName.assign("CheckedIn");
               }
               break;
            case "O":
               {
                  rStateName.assign("CheckedOut");
               }
               break;
            default:
               {
                  rStateName.assign("n/a");
               }
               break;
         }
         
         FrameElement[] elementList1 = new FrameElement[]
         {
            new Element(rId, fResFrame.widgetRId()),
            new Element(rCheckin, fResFrame.widgetRCheckin()),
            new Element(rCheckout, fResFrame.widgetRCheckout()),
            new Element(rDiscount, fResFrame.widgetRDiscount()),
            new Element(rState, fResFrame.widgetRState()),
            new Element(rStateName, fResFrame.widgetRStateName()),
            new Element(gId, fResFrame.widgetGId()),
            new Element(gFN, fResFrame.widgetGFN()),
            new Element(gLN, fResFrame.widgetGLN()),
            new Element(gDob, fResFrame.widgetGDob()),
            new Element(gPhoneNumber, fResFrame.widgetGPhoneNumber())
         };
         
         fResFrame.display(elementList1);
         
         fResRoomsFrame.clearAll(false);
         
         AdaptiveQuery query2 = new AdaptiveQuery();
         
         forEach("loopLabel0", new Block((Init) () -> 
         {
            query2.initialize(bResRoom, "bResRoom.reservationId = ?", null, "bResRoom.id asc", new Object[]
            {
               rId
            });
         }, 
         (Body) () -> 
         {
            query2.next();
            rType.assign(subscript(roomTypes, bResRoom.getTypeOfRoom()));
            rRooms.assign(bResRoom.getRooms());
            
            FrameElement[] elementList2 = new FrameElement[]
            {
               new Element(rType, fResRoomsFrame.widgetRType()),
               new Element(rRooms, fResRoomsFrame.widgetRRooms())
            };
            
            fResRoomsFrame.display(elementList2);
            
            fResRoomsFrame.down(1);
         }));
      }));
   }

   public void chooseGuest(final integer gId_1)
   {
      integer tFGuests = UndoableFactory.integer();
      logical gAdd = UndoableFactory.logical();
      
      internalProcedure(new Block((Pre) () -> 
      {
         chooseGuestFAddGuestFrame = GenericFrame.createFrame(ReservationsChooseGuestFAddGuest.class, "chooseGuest-f-add-guest");
         chooseGuestFSearchFrame = GenericFrame.createFrame(ReservationsChooseGuestFSearch.class, "chooseGuest-f-search");
      }, 
      (Init) () -> 
      {
         UndoableFactory.initOutput(gId_1, new integer());
      }, 
      (Body) () -> 
      {
         OnPhrase[] onPhrase0 = new OnPhrase[]
         {
            new OnPhrase(Condition.ENDKEY, Action.LEAVE, "gSearch")
         };
         
         repeat("gSearch", onPhrase0, new Block((Init) () -> 
         {
            chooseGuestFSearchFrame.openScope();
            chooseGuestFAddGuestFrame.openScope();
         }, 
         (Body) () -> 
         {
            FrameElement[] elementList3 = new FrameElement[]
            {
               new Element(gFN, chooseGuestFSearchFrame.widgetGFN()),
               new Element(gLN, chooseGuestFSearchFrame.widgetGLN()),
               new Element(gDob, chooseGuestFSearchFrame.widgetGDob())
            };
            
            chooseGuestFSearchFrame.update(elementList3);
            
            if (_and(and(isEqual(gFN, ""), () -> isEqual(gLN, "")), () -> isUnknown(gDob)))
            {
               message("Enter at least one search criteri!");
               next("gSearch");
            }
            
            tFGuests.assign(0);
            gId_1.setUnknown();
            
            AdaptiveQuery query3 = new AdaptiveQuery();
            
            forEach("loopLabel1", new Block((Init) () -> 
            {
               query3.initialize(bGuest, "case when ? then true else upper(bGuest.firstName) like ? end and case when ? then true else upper(bGuest.lastName) like ? end and case when ? then true else bGuest.dateOfBirth = ? end", null, "bGuest.guestId asc", new Object[]
               {
                  or(isUnknown(gFN), () -> isEqual(gFN, "")),
                  toUpperCase(convertToSQLLike(concat(gFN, "*"), false)),
                  or(isUnknown(gLN), () -> isEqual(gLN, "")),
                  toUpperCase(convertToSQLLike(concat(gLN, "*"), false)),
                  isUnknown(gDob),
                  gDob
               }, LockType.NONE);
            }, 
            (Body) () -> 
            {
               query3.next();
               tFGuests.assign(plus(tFGuests, 1));
               
               if (_isEqual(tFGuests, 1))
               {
                  gId_1.assign(bGuest.getGuestId());
               }
               else
               {
                  if (_isGreaterThanOrEqual(tFGuests, 2))
                  {
                     leave("loopLabel1");
                  }
               }
            }));
            
            if (_isGreaterThan(tFGuests, 0))
            {
               if (_isEqual(tFGuests, 1))
               {
                  leave("gSearch");
               }
               
               query0.assign(new AdaptiveQuery().initialize(bGuest, "case when ? then true else upper(bGuest.firstName) like ? end and case when ? then true else upper(bGuest.lastName) like ? end and case when ? then true else bGuest.dateOfBirth = ? end", null, "bGuest.guestId asc", "WHOLE-INDEX,idx-g-id", new Object[]
               {
                  or(isUnknown(gFN), () -> isEqual(gFN, "")),
                  toUpperCase(convertToSQLLike(concat(gFN, "*"), false)),
                  or(isUnknown(gLN), () -> isEqual(gLN, "")),
                  toUpperCase(convertToSQLLike(concat(gLN, "*"), false)),
                  isUnknown(gDob),
                  gDob
               }));
               query0.open();
               
               FrameElement[] elementList4 = new FrameElement[]
               {
                  new WidgetElement(fGuestsFrame.widgetBrwsGuest())
               };
               
               fGuestsFrame.update(elementList4);
               
               fGuestsFrame.hide(true);
               
               gId_1.assign(bGuest.getGuestId());
               leave("gSearch");
            }
            else
            {
               messageBox("Guest not found! Add new guest?", false, new AccessorWrapper(gAdd), ALERT_MESSAGE, BTN_YES_NO, (String) null);
               
               if ((gAdd).booleanValue())
               {
                  OnPhrase[] onPhrase1 = new OnPhrase[]
                  {
                     new OnPhrase(Condition.ERROR, Action.LEAVE, "blockLabel0"),
                     new OnPhrase(Condition.ENDKEY, Action.LEAVE, "blockLabel0")
                  };
                  
                  doBlock(TransactionType.FULL, "blockLabel0", onPhrase1, new Block((Body) () -> 
                  {
                     ErrorManager.silentErrorEnable();
                     new FindQuery(bGuest, (String) null, null, "bGuest.guestId asc", LockType.NONE).last();
                     ErrorManager.silentErrorDisable();
                     gId_1.assign((bGuest._available() ? plus(bGuest.getGuestId(), 1) : new int64(1)));
                     bGuest.release();
                     bGuest.create();
                     bGuest.setGuestId(gId_1);
                     
                     FrameElement[] elementList5 = new FrameElement[]
                     {
                        new Element(new FieldReference(bGuest, "guestId"), chooseGuestFAddGuestFrame.widgetGuestId())
                     };
                     
                     chooseGuestFAddGuestFrame.display(elementList5);
                     
                     FrameElement[] elementList6 = new FrameElement[]
                     {
                        new Element(new FieldReference(bGuest, "firstName"), chooseGuestFAddGuestFrame.widgetFirstName()),
                        new Element(new FieldReference(bGuest, "lastName"), chooseGuestFAddGuestFrame.widgetLastName()),
                        new Element(new FieldReference(bGuest, "dateOfBirth"), chooseGuestFAddGuestFrame.widgetDateOfBirth())
                     };
                     
                     chooseGuestFAddGuestFrame.update(elementList6);
                     
                     chooseGuestFAddGuestFrame.hide(true);
                     
                     bGuest.release();
                  }));
                  
                  leave("gSearch");
               }
            }
         }));
         
         chooseGuestFSearchFrame.hide(true);
      }));
   }

   public class TriggerBlock0
   extends Trigger
   {
      integer gId_1 = UndoableFactory.integer();

      public void body()
      {
         if (_isEqual(focus().unwrapWidget().getScreenValue(), "?"))
         {
            ControlFlowOps.invokeWithMode("choose-guest", "O", gId_1);
            
            if (_isUnknown(gId_1))
            {
               returnConsume();
            }
            
            focus().unwrapWidget().setScreenValue(valueOf(gId_1));
         }
         else
         {
            gId_1.assign(new integer(focus().unwrapWidget().getScreenValue()));
         }
         
         if (_isNotEqual(gId_1, 0))
         {
            new FindQuery(bGuest, "bGuest.guestId = ?", null, "bGuest.guestId asc", new Object[]
            {
               gId_1
            }, LockType.NONE).unique();
            focus().unwrap().getNextSibling().unwrapWidget().setScreenValue(concat(bGuest.getFirstName(), " ", bGuest.getLastName()));
         }
      }
   }
}
