package com.goldencode.hotel.dmo.hotel;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>hotel.rate</code> (previously
 * <code>hotel.rate</code>).
 */
public interface Rate
extends DataModelObject
{
   /**
    * Getter: Type of Room
    * 
    * @return  Type of Room
    */
   public integer getTypeOfRoom();

   /**
    * Setter: Type of Room
    * 
    * @param   typeOfRoom
    *          Type of Room
    */
   public void setTypeOfRoom(NumberType typeOfRoom);

   /**
    * Getter: Floor
    * 
    * @return  Floor
    */
   public integer getFloor();

   /**
    * Setter: Floor
    * 
    * @param   floor
    *          Floor
    */
   public void setFloor(NumberType floor);

   /**
    * Getter: Rate
    * 
    * @return  Rate
    */
   public decimal getRate();

   /**
    * Setter: Rate
    * 
    * @param   rate
    *          Rate
    */
   public void setRate(NumberType rate);

   /**
    * Getter: From Date
    * 
    * @return  From Date
    */
   public date getStartDate();

   /**
    * Setter: From Date
    * 
    * @param   startDate
    *          From Date
    */
   public void setStartDate(date startDate);

   /**
    * Getter: To Date
    * 
    * @return  To Date
    */
   public date getEndDate();

   /**
    * Setter: To Date
    * 
    * @param   endDate
    *          To Date
    */
   public void setEndDate(date endDate);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends Rate, Buffer
   {
   }
}
