package com.goldencode.hotel.dmo.hotel.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo.hotel.*;

/**
 * Data Model Object corresponding with table <code>hotel.meta_user</code> (previously
 * <code>hotel._user</code>).
 */
@LegacyTable(name = "_user", table = "meta_user")
@LegacyIndexes(
{
   @LegacyIndex(name = "_userid", converted = "meta_user_userid", primary = true, unique = true, components = 
   {
      @LegacyIndexComponent(fieldName = "_userid")
   })
})
public class MetaUserImpl
implements Serializable,
           Persistable,
           MetaUser
{
   /** Surrogate primary key */
   private Long id = null;

   /** Userid */
   @LegacyField(fieldId = 1, name = "_userid", format = "x(12)", initial = "?", label = "Userid", mandatory = true)
   private final character userid;

   /** Password */
   @LegacyField(fieldId = 2, name = "_password", format = "x(16)", initial = "?", label = "Password", mandatory = true)
   private final character password;

   /** User-Name */
   @LegacyField(fieldId = 3, name = "_user-name", format = "x(40)", label = "User-Name")
   private final character userName;

   /** User-Misc */
   @LegacyField(fieldId = 6, name = "_user-misc", format = "x(10)", initial = "?", label = "User-Misc")
   private final character userMisc;

   /** User_number */
   @LegacyField(fieldId = 7, name = "_user_number", format = ">>>>>>9", initial = "?", label = "User_number")
   private final integer userNumber;

   /** Group_number */
   @LegacyField(fieldId = 8, name = "_group_number", format = ">>>>>>9", initial = "?", label = "Group_number")
   private final integer groupNumber;

   /** Given_name */
   @LegacyField(fieldId = 9, name = "_given_name", format = "x(25)", initial = "?", label = "Given_name")
   private final character givenName;

   /** Middle_initial */
   @LegacyField(fieldId = 10, name = "_middle_initial", format = "x(1)", initial = "?", label = "Middle_initial")
   private final character middleInitial;

   /** Surname */
   @LegacyField(fieldId = 11, name = "_surname", format = "x(25)", initial = "?", label = "Surname")
   private final character surname;

   /** Telephone */
   @LegacyField(fieldId = 12, name = "_telephone", format = "x(20)", initial = "?", label = "Telephone")
   private final character telephone;

   /** Email */
   @LegacyField(fieldId = 13, name = "_email", format = "x(50)", initial = "?", label = "Email")
   private final character email;

   /** Description */
   @LegacyField(fieldId = 14, name = "_description", format = "x(64)", initial = "?", label = "Description")
   private final character description;

   /** Disabled */
   @LegacyField(fieldId = 15, name = "_disabled", format = "yes/no", initial = "?", label = "Disabled")
   private final logical disabled;

   /** Create_date */
   @LegacyField(fieldId = 16, name = "_create_date", format = "99/99/9999 HH:MM:SS.SSS+HH:MM", initial = "?", label = "Create_date")
   private final datetimetz createDate;

   /** Account_expires */
   @LegacyField(fieldId = 17, name = "_account_expires", format = "99/99/9999 HH:MM:SS.SSS+HH:MM", initial = "?", label = "Account_expires")
   private final datetimetz accountExpires;

   /** Pwd_expires */
   @LegacyField(fieldId = 18, name = "_pwd_expires", format = "99/99/9999 HH:MM:SS.SSS+HH:MM", initial = "?", label = "Pwd_expires")
   private final datetimetz pwdExpires;

   /** Pwd_duration */
   @LegacyField(fieldId = 19, name = "_pwd_duration", format = ">>>>>>9", initial = "?", label = "Pwd_duration")
   private final integer pwdDuration;

   /** Last_login */
   @LegacyField(fieldId = 20, name = "_last_login", format = "99/99/9999 HH:MM:SS.SSS+HH:MM", initial = "?", label = "Last_login")
   private final datetimetz lastLogin;

   /** Logins */
   @LegacyField(fieldId = 21, name = "_logins", format = ">>>>>>9", initial = "?", label = "Logins")
   private final integer logins;

   /** Max_logins */
   @LegacyField(fieldId = 22, name = "_max_logins", format = ">>>>>>9", initial = "?", label = "Max_logins")
   private final integer maxLogins;

   /** Max_tries */
   @LegacyField(fieldId = 23, name = "_max_tries", format = ">>>>>>9", initial = "?", label = "Max_tries")
   private final integer maxTries;

   /** Login_failures */
   @LegacyField(fieldId = 24, name = "_login_failures", format = ">>>>>>9", initial = "?", label = "Login_failures")
   private final integer loginFailures;

   /** Spare1 */
   @LegacyField(fieldId = 25, name = "_spare1", format = ">>>>>>9", initial = "?", label = "Spare1")
   private final integer spare1;

   /** Spare2 */
   @LegacyField(fieldId = 26, name = "_spare2", format = ">>>>>>9", initial = "?", label = "Spare2")
   private final integer spare2;

   /** Spare3 */
   @LegacyField(fieldId = 27, name = "_spare3", format = "x(1)", initial = "?", label = "Spare3")
   private final character spare3;

   /** Spare4 */
   @LegacyField(fieldId = 28, name = "_spare4", format = "x(1)", initial = "?", label = "Spare4")
   private final character spare4;

   /** List of composite properties; 8 elements of type {@link MetaUserImpl.Composite8 Composite8} */
   private List<Composite8> composite8 = new ArrayList<>(8);

   /**
    * Default constructor.
    */
   public MetaUserImpl()
   {
      userid = new character("?");
      password = new character("?");
      userName = new character("");
      userMisc = new character("?");
      userNumber = new integer();
      groupNumber = new integer();
      givenName = new character("?");
      middleInitial = new character("?");
      surname = new character("?");
      telephone = new character("?");
      email = new character("?");
      description = new character("?");
      disabled = new logical();
      createDate = new datetimetz();
      accountExpires = new datetimetz();
      pwdExpires = new datetimetz();
      pwdDuration = new integer();
      lastLogin = new datetimetz();
      logins = new integer();
      maxLogins = new integer();
      maxTries = new integer();
      loginFailures = new integer();
      spare1 = new integer();
      spare2 = new integer();
      spare3 = new character("?");
      spare4 = new character("?");
      
      // Populate Composite8 list.
      for (int i = 0; i < 8; i++)
      {
         composite8.add(new Composite8());
      }
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new MetaUserImpl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      MetaUserImpl from = (MetaUserImpl) old;
      setId(from.id);
      setUserid(from.userid);
      setPassword(from.password);
      setUserName(from.userName);
      setUserMisc(from.userMisc);
      setUserNumber(from.userNumber);
      setGroupNumber(from.groupNumber);
      setGivenName(from.givenName);
      setMiddleInitial(from.middleInitial);
      setSurname(from.surname);
      setTelephone(from.telephone);
      setEmail(from.email);
      setDescription(from.description);
      setDisabled(from.disabled);
      setCreateDate(from.createDate);
      setAccountExpires(from.accountExpires);
      setPwdExpires(from.pwdExpires);
      setPwdDuration(from.pwdDuration);
      setLastLogin(from.lastLogin);
      setLogins(from.logins);
      setMaxLogins(from.maxLogins);
      setMaxTries(from.maxTries);
      setLoginFailures(from.loginFailures);
      setSpare1(from.spare1);
      setSpare2(from.spare2);
      setSpare3(from.spare3);
      setSpare4(from.spare4);
      
      // Assign Composite8 properties.
      for (int i = 0; i < 8; i++)
      {
         setUMisc1(i, from.composite8.get(i).UMisc1);
         setUMisc2(i, from.composite8.get(i).UMisc2);
      }
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: Userid
    * 
    * @return  Userid
    */
   public character getUserid()
   {
      return (new character(userid));
   }

   /**
    * Setter: Userid
    * 
    * @param   userid
    *          Userid
    */
   public void setUserid(Text userid)
   {
      this.userid.assign(userid, true);
   }

   /**
    * Getter: Password
    * 
    * @return  Password
    */
   public character getPassword()
   {
      return (new character(password));
   }

   /**
    * Setter: Password
    * 
    * @param   password
    *          Password
    */
   public void setPassword(Text password)
   {
      this.password.assign(password, true);
   }

   /**
    * Getter: User-Name
    * 
    * @return  User-Name
    */
   public character getUserName()
   {
      return (new character(userName));
   }

   /**
    * Setter: User-Name
    * 
    * @param   userName
    *          User-Name
    */
   public void setUserName(Text userName)
   {
      this.userName.assign(userName, true);
   }

   /**
    * Indexed Getter: UMisc1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  UMisc1
    */
   public integer getUMisc1(int index)
   {
      return composite8.get(index).getUMisc1();
   }

   /**
    * Indexed Setter: UMisc1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          UMisc1
    */
   public void setUMisc1(int index, NumberType element)
   {
      composite8.get(index).setUMisc1(element);
   }

   /**
    * Indexed Getter: UMisc2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  UMisc2
    */
   public character getUMisc2(int index)
   {
      return composite8.get(index).getUMisc2();
   }

   /**
    * Indexed Setter: UMisc2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          UMisc2
    */
   public void setUMisc2(int index, Text element)
   {
      composite8.get(index).setUMisc2(element);
   }

   /**
    * Getter: User-Misc
    * 
    * @return  User-Misc
    */
   public character getUserMisc()
   {
      return (new character(userMisc));
   }

   /**
    * Setter: User-Misc
    * 
    * @param   userMisc
    *          User-Misc
    */
   public void setUserMisc(Text userMisc)
   {
      this.userMisc.assign(userMisc, true);
   }

   /**
    * Getter: User_number
    * 
    * @return  User_number
    */
   public integer getUserNumber()
   {
      return (new integer(userNumber));
   }

   /**
    * Setter: User_number
    * 
    * @param   userNumber
    *          User_number
    */
   public void setUserNumber(NumberType userNumber)
   {
      this.userNumber.assign(userNumber, true);
   }

   /**
    * Getter: Group_number
    * 
    * @return  Group_number
    */
   public integer getGroupNumber()
   {
      return (new integer(groupNumber));
   }

   /**
    * Setter: Group_number
    * 
    * @param   groupNumber
    *          Group_number
    */
   public void setGroupNumber(NumberType groupNumber)
   {
      this.groupNumber.assign(groupNumber, true);
   }

   /**
    * Getter: Given_name
    * 
    * @return  Given_name
    */
   public character getGivenName()
   {
      return (new character(givenName));
   }

   /**
    * Setter: Given_name
    * 
    * @param   givenName
    *          Given_name
    */
   public void setGivenName(Text givenName)
   {
      this.givenName.assign(givenName, true);
   }

   /**
    * Getter: Middle_initial
    * 
    * @return  Middle_initial
    */
   public character getMiddleInitial()
   {
      return (new character(middleInitial));
   }

   /**
    * Setter: Middle_initial
    * 
    * @param   middleInitial
    *          Middle_initial
    */
   public void setMiddleInitial(Text middleInitial)
   {
      this.middleInitial.assign(middleInitial, true);
   }

   /**
    * Getter: Surname
    * 
    * @return  Surname
    */
   public character getSurname()
   {
      return (new character(surname));
   }

   /**
    * Setter: Surname
    * 
    * @param   surname
    *          Surname
    */
   public void setSurname(Text surname)
   {
      this.surname.assign(surname, true);
   }

   /**
    * Getter: Telephone
    * 
    * @return  Telephone
    */
   public character getTelephone()
   {
      return (new character(telephone));
   }

   /**
    * Setter: Telephone
    * 
    * @param   telephone
    *          Telephone
    */
   public void setTelephone(Text telephone)
   {
      this.telephone.assign(telephone, true);
   }

   /**
    * Getter: Email
    * 
    * @return  Email
    */
   public character getEmail()
   {
      return (new character(email));
   }

   /**
    * Setter: Email
    * 
    * @param   email
    *          Email
    */
   public void setEmail(Text email)
   {
      this.email.assign(email, true);
   }

   /**
    * Getter: Description
    * 
    * @return  Description
    */
   public character getDescription()
   {
      return (new character(description));
   }

   /**
    * Setter: Description
    * 
    * @param   description
    *          Description
    */
   public void setDescription(Text description)
   {
      this.description.assign(description, true);
   }

   /**
    * Getter: Disabled
    * 
    * @return  Disabled
    */
   public logical isDisabled()
   {
      return (new logical(disabled));
   }

   /**
    * Setter: Disabled
    * 
    * @param   disabled
    *          Disabled
    */
   public void setDisabled(logical disabled)
   {
      this.disabled.assign(disabled, true);
   }

   /**
    * Getter: Create_date
    * 
    * @return  Create_date
    */
   public datetimetz getCreateDate()
   {
      return (new datetimetz(createDate));
   }

   /**
    * Setter: Create_date
    * 
    * @param   createDate
    *          Create_date
    */
   public void setCreateDate(date createDate)
   {
      this.createDate.assign(createDate, true);
   }

   /**
    * Getter: Account_expires
    * 
    * @return  Account_expires
    */
   public datetimetz getAccountExpires()
   {
      return (new datetimetz(accountExpires));
   }

   /**
    * Setter: Account_expires
    * 
    * @param   accountExpires
    *          Account_expires
    */
   public void setAccountExpires(date accountExpires)
   {
      this.accountExpires.assign(accountExpires, true);
   }

   /**
    * Getter: Pwd_expires
    * 
    * @return  Pwd_expires
    */
   public datetimetz getPwdExpires()
   {
      return (new datetimetz(pwdExpires));
   }

   /**
    * Setter: Pwd_expires
    * 
    * @param   pwdExpires
    *          Pwd_expires
    */
   public void setPwdExpires(date pwdExpires)
   {
      this.pwdExpires.assign(pwdExpires, true);
   }

   /**
    * Getter: Pwd_duration
    * 
    * @return  Pwd_duration
    */
   public integer getPwdDuration()
   {
      return (new integer(pwdDuration));
   }

   /**
    * Setter: Pwd_duration
    * 
    * @param   pwdDuration
    *          Pwd_duration
    */
   public void setPwdDuration(NumberType pwdDuration)
   {
      this.pwdDuration.assign(pwdDuration, true);
   }

   /**
    * Getter: Last_login
    * 
    * @return  Last_login
    */
   public datetimetz getLastLogin()
   {
      return (new datetimetz(lastLogin));
   }

   /**
    * Setter: Last_login
    * 
    * @param   lastLogin
    *          Last_login
    */
   public void setLastLogin(date lastLogin)
   {
      this.lastLogin.assign(lastLogin, true);
   }

   /**
    * Getter: Logins
    * 
    * @return  Logins
    */
   public integer getLogins()
   {
      return (new integer(logins));
   }

   /**
    * Setter: Logins
    * 
    * @param   logins
    *          Logins
    */
   public void setLogins(NumberType logins)
   {
      this.logins.assign(logins, true);
   }

   /**
    * Getter: Max_logins
    * 
    * @return  Max_logins
    */
   public integer getMaxLogins()
   {
      return (new integer(maxLogins));
   }

   /**
    * Setter: Max_logins
    * 
    * @param   maxLogins
    *          Max_logins
    */
   public void setMaxLogins(NumberType maxLogins)
   {
      this.maxLogins.assign(maxLogins, true);
   }

   /**
    * Getter: Max_tries
    * 
    * @return  Max_tries
    */
   public integer getMaxTries()
   {
      return (new integer(maxTries));
   }

   /**
    * Setter: Max_tries
    * 
    * @param   maxTries
    *          Max_tries
    */
   public void setMaxTries(NumberType maxTries)
   {
      this.maxTries.assign(maxTries, true);
   }

   /**
    * Getter: Login_failures
    * 
    * @return  Login_failures
    */
   public integer getLoginFailures()
   {
      return (new integer(loginFailures));
   }

   /**
    * Setter: Login_failures
    * 
    * @param   loginFailures
    *          Login_failures
    */
   public void setLoginFailures(NumberType loginFailures)
   {
      this.loginFailures.assign(loginFailures, true);
   }

   /**
    * Getter: Spare1
    * 
    * @return  Spare1
    */
   public integer getSpare1()
   {
      return (new integer(spare1));
   }

   /**
    * Setter: Spare1
    * 
    * @param   spare1
    *          Spare1
    */
   public void setSpare1(NumberType spare1)
   {
      this.spare1.assign(spare1, true);
   }

   /**
    * Getter: Spare2
    * 
    * @return  Spare2
    */
   public integer getSpare2()
   {
      return (new integer(spare2));
   }

   /**
    * Setter: Spare2
    * 
    * @param   spare2
    *          Spare2
    */
   public void setSpare2(NumberType spare2)
   {
      this.spare2.assign(spare2, true);
   }

   /**
    * Getter: Spare3
    * 
    * @return  Spare3
    */
   public character getSpare3()
   {
      return (new character(spare3));
   }

   /**
    * Setter: Spare3
    * 
    * @param   spare3
    *          Spare3
    */
   public void setSpare3(Text spare3)
   {
      this.spare3.assign(spare3, true);
   }

   /**
    * Getter: Spare4
    * 
    * @return  Spare4
    */
   public character getSpare4()
   {
      return (new character(spare4));
   }

   /**
    * Setter: Spare4
    * 
    * @param   spare4
    *          Spare4
    */
   public void setSpare4(Text spare4)
   {
      this.spare4.assign(spare4, true);
   }

   /**
    * Inner class which composites properties of like extent. All properties migrated from the
    * legacy table <code>hotel._user</code> of extent 8 are data members of this class.
    */
   static class Composite8
   implements Serializable
   {
      /** Data member */
      @LegacyField(fieldId = 4, name = "_u-misc1", format = ">>>>9", initial = "?", extent = 8)
      private final integer UMisc1;

      /** Data member */
      @LegacyField(fieldId = 5, name = "_u-misc2", format = "x(8)", initial = "?", extent = 8)
      private final character UMisc2;

      /**
       * Default constructor.
       */
      public Composite8()
      {
         UMisc1 = new integer();
         UMisc2 = new character("?");
      }

      /**
       * Getter: UMisc1
       * 
       * @return  UMisc1
       */
      public integer getUMisc1()
      {
         return (new integer(UMisc1));
      }

      /**
       * Setter: UMisc1
       * 
       * @param   UMisc1
       *          UMisc1
       */
      public void setUMisc1(NumberType UMisc1)
      {
         this.UMisc1.assign(UMisc1, true);
      }

      /**
       * Getter: UMisc2
       * 
       * @return  UMisc2
       */
      public character getUMisc2()
      {
         return (new character(UMisc2));
      }

      /**
       * Setter: UMisc2
       * 
       * @param   UMisc2
       *          UMisc2
       */
      public void setUMisc2(Text UMisc2)
      {
         this.UMisc2.assign(UMisc2, true);
      }
   }
}
