package com.goldencode.hotel.dmo.hotel.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo.hotel.*;

/**
 * Data Model Object corresponding with table <code>hotel.reservation_rooms</code> (previously
 * <code>hotel.reservation-rooms</code>).
 */
@LegacyTable(name = "reservation-rooms", table = "reservation_rooms")
public class ReservationRoomsImpl
implements Serializable,
           Persistable,
           ReservationRooms
{
   /** Surrogate primary key */
   private Long id = null;

   /** ID */
   @LegacyField(fieldId = 1, name = "reservation-id", format = ">,>>>,>>9", initial = "0", columnLabel = "ID", label = "ID")
   private final integer reservationId;

   /** Type of Room */
   @LegacyField(fieldId = 2, name = "type-of-room", format = ">>9", initial = "0", columnLabel = "Type of Room", label = "Type of Room", mandatory = true)
   private final integer typeOfRoom;

   /** No. of Rooms */
   @LegacyField(fieldId = 3, name = "rooms", format = ">>9", initial = "0", columnLabel = "No. of Rooms", label = "No. of Rooms")
   private final integer rooms;

   /**
    * Default constructor.
    */
   public ReservationRoomsImpl()
   {
      reservationId = new integer(0);
      typeOfRoom = new integer(0);
      rooms = new integer(0);
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new ReservationRoomsImpl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      ReservationRoomsImpl from = (ReservationRoomsImpl) old;
      setId(from.id);
      setReservationId(from.reservationId);
      setTypeOfRoom(from.typeOfRoom);
      setRooms(from.rooms);
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: ID
    * 
    * @return  ID
    */
   public integer getReservationId()
   {
      return (new integer(reservationId));
   }

   /**
    * Setter: ID
    * 
    * @param   reservationId
    *          ID
    */
   public void setReservationId(NumberType reservationId)
   {
      this.reservationId.assign(reservationId, true);
   }

   /**
    * Getter: Type of Room
    * 
    * @return  Type of Room
    */
   public integer getTypeOfRoom()
   {
      return (new integer(typeOfRoom));
   }

   /**
    * Setter: Type of Room
    * 
    * @param   typeOfRoom
    *          Type of Room
    */
   public void setTypeOfRoom(NumberType typeOfRoom)
   {
      this.typeOfRoom.assign(typeOfRoom, true);
   }

   /**
    * Getter: No. of Rooms
    * 
    * @return  No. of Rooms
    */
   public integer getRooms()
   {
      return (new integer(rooms));
   }

   /**
    * Setter: No. of Rooms
    * 
    * @param   rooms
    *          No. of Rooms
    */
   public void setRooms(NumberType rooms)
   {
      this.rooms.assign(rooms, true);
   }
}
